package com.brilliance.ccbank.common;

import com.brilliance.eibs.core.model.IFilterDef;
import com.brilliance.eibs.core.model.IStepDef;
import com.brilliance.eibs.core.model.impl.FilterDef;

public class FilterUtil {
	/**
	 * 获取定长报文的Filter
	 * @return
	 */
	public static IFilterDef getFixedFilterDef(IStepDef stepDef,String string_fillchar,String fill_string_strategy,String number_fillchar,String fill_number_strategy,String type,String encoding){
		IFilterDef filterDef = new FilterDef();
		filterDef.setParentDef(stepDef);
		filterDef.addCommonsProperty("string_fillchar", string_fillchar);
	    filterDef.addCommonsProperty("number_fillchar", number_fillchar);
	    filterDef.addCommonsProperty("fill_number_strategy", fill_number_strategy);
	    filterDef.addCommonsProperty("fill_string_strategy", fill_string_strategy);
	    filterDef.setType(type);
		filterDef.setEncoding(encoding);
	    filterDef.setRef("fixedFilter");
	    filterDef.setId("fixedFilter");
	    filterDef.setExecuteClass("FixedFilter");
	    
		return filterDef;
	}
	
	public static IFilterDef getFixedFilterDef(IStepDef stepDef,String type,String encoding){
		String string_fillchar=" ";
		String fill_string_strategy="right";
		String number_fillchar="0";
		String fill_number_strategy="left";
		return getFixedFilterDef(stepDef, string_fillchar, fill_string_strategy, number_fillchar, fill_number_strategy, type, encoding);
	}
	
	public static IFilterDef getFixedFilterDef(IStepDef stepDef,String type){
		String string_fillchar=" ";
		String fill_string_strategy="right";
		String number_fillchar="0";
		String fill_number_strategy="left";
		String encoding="UTF-8";
		return getFixedFilterDef(stepDef, string_fillchar, fill_string_strategy, number_fillchar, fill_number_strategy, type, encoding);
	}
	
	/**
	 * 获取变长有分隔符报文的Filter
	 * @return
	 */
	public static IFilterDef getSplitFilterDef(IStepDef stepDef,String split_strategy,String type,String encoding){
		IFilterDef filterDef = new FilterDef();
		filterDef.setParentDef(stepDef);
	    filterDef.setEncoding(encoding);
	    filterDef.addCommonsProperty("split_strategy", split_strategy);
	    filterDef.setType(type);
	    filterDef.setRef("splitFilter");
	    filterDef.setId("splitFilter");
	    filterDef.setExecuteClass("SplitFilter");
		return filterDef;
	}
	
	public static IFilterDef getSplitFilterDef(IStepDef stepDef,String split_strategy,String type){
		String encoding = "UTF-8";
		return getSplitFilterDef(stepDef, split_strategy, type, encoding);
	}
	
	/**
	 * 获取xml报文的Filter
	 */
	
	public static IFilterDef getXmlFilterDef(){
		return null;
	}
	
	/**
	 * 获取socket报文的Filter
	 */
	public static IFilterDef getSocketFilterDef(IStepDef stepDef,String type,String encoding){
		IFilterDef filterDef = new FilterDef();
		filterDef.setParentDef(stepDef);
		filterDef.setRef("socketFilter");
	    filterDef.setId("socketFilter");
	    filterDef.setType(type);
	    filterDef.setEncoding(encoding);
	    filterDef.setExecuteClass("SocketFilter");
		return filterDef;
	}
	
	public static IFilterDef getSocketFilterDef(IStepDef stepDef,String type){
		String encoding="UTF-8";
		return getSocketFilterDef(stepDef, type, encoding);
	}
}
