package com.brilliance.ccbank.service.impl;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import com.brilliance.ccbank.service.abs.AbsProcessEngine;
import com.brilliance.ccbank.srcipt.core.FlwMapping;
import com.brilliance.ccbank.srcipt.core.ScriptParser;
import com.brilliance.ccbank.srcipt.model.impl.BeginDef;
import com.brilliance.ccbank.srcipt.model.impl.EndDef;
import com.brilliance.ccbank.srcipt.model.impl.ScriptCallDef;
import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.core.model.impl.AbsDef;
import com.brilliance.eibs.core.model.impl.FilterDef;
import com.brilliance.eibs.core.model.impl.IfDef;

/**
 * @author ge
 * 获取流程引擎
 * ***/
/**
 * @author ge
 *
 */
public class FlwEngineService
    extends AbsProcessEngine
{
  @Override
  public String getProcessDefDefine(String id)
  {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public List<IAbsDef> getProcessEngine(List<FlwMapping> script)
  {
    try
    {
      return ScriptParser.dbParse(script, null);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      return null;
    }
  }
  
  
  /**
   * 处理每个交易的处理流程引擎
   * ***/
  public  void handleFlwList(List<IAbsDef> flwlist, AbsDef parentDef)
  {
    for (IAbsDef iAbsDef : flwlist)
    {
      if (iAbsDef instanceof BeginDef)
      {
        // parentDef.getExecuteList().add()
        // 查找场景组件输入
      }
      if (iAbsDef instanceof ScriptCallDef)
      {
        parentDef.getExecuteList().add(iAbsDef);
        iAbsDef.setParentDef(parentDef);
        //查找基础组件或者业务组件  先只考虑业务组件
      }
      if (iAbsDef instanceof EndDef)
      {
        // parentDef.getExecuteList().add(ss)
        //处理场景组件输出返回值
      }
      if (iAbsDef instanceof IfDef)
      {
        IfDef innerifDef = new IfDef();
        parentDef.getExecuteList().add(innerifDef);
        innerifDef.setParentDef(parentDef);

        IfDef flwifDef = (IfDef) iAbsDef;
        Map<String, Object> map = flwifDef.getConditionMap();
        for (String condition : map.keySet())
        {
          List<IAbsDef> flwConditionList = (List<IAbsDef>) map.get(condition);
          handleEveryFlwIf(condition, flwConditionList, innerifDef);
        }
      }
    }
  }

  public  void handleEveryFlwIf(String condition, List<IAbsDef> flwConditionList, IfDef innerifDef)
  {

    List<IAbsDef> newlist = new ArrayList<IAbsDef>();

    //需要处理condition 把处理condtion的Filter加入newlist

    for (IAbsDef iAbsDef : flwConditionList)
    {
      //处理if下的子节点
      Object retDef = getInnerdef(iAbsDef);
      if (retDef instanceof IAbsDef)
      {
        newlist.add((IAbsDef) retDef);
      }
      else if (retDef instanceof List)
      {
        List<IAbsDef> ret = (List<IAbsDef>) retDef;
        for (IAbsDef everyDef : ret)
        {
          newlist.add(everyDef);
        }
      }
    }
    innerifDef.addConditionMap(condition, newlist);
  }

  /**
   * 模型对象转换成内部对象定义
   * **/
  public  Object getInnerdef(IAbsDef oldDef)
  {
    if (oldDef instanceof BeginDef)
    {
      // parentDef.getExecuteList().add(ss)
    }
    if (oldDef instanceof ScriptCallDef)
    {
      FilterDef f = new FilterDef();
      return f;
    }
    if (oldDef instanceof EndDef)
    {
      // parentDef.getExecuteList().add(ss)
      FilterDef f = new FilterDef();
      return f;
    }
    if (oldDef instanceof IfDef)
    {
      IfDef ifDef = (IfDef) oldDef;
      Map<String, Object> map = ifDef.getConditionMap();
      for (String key : map.keySet())
      {
        List<IAbsDef> list2 = (List<IAbsDef>) map.get(key);
        handleEveryFlwIf(key, list2, ifDef);
      }
      return ifDef;
    }
    return null;
  }
  
  
  public  List<FlwMapping> makeScript()
  {
    List<FlwMapping> sc = new LinkedList<FlwMapping>();

    FlwMapping fm = null;

    fm = new FlwMapping.Builder("LC01", -1, 1).build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 1, 2).compId("000000001").compTyp("BC").build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 2, 3).compId("000000002").compTyp("BC").build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 3, 4).compId("000000003").compTyp("BC").build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 4, 5).compId("000000004").compTyp("CC").retVal(0).build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 4, 6).compId("000000004").compTyp("CC").retVal(1).build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 5, -2).compId("000000005").compTyp("BC").build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 6, 7).compId("000000006").compTyp("BC").build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 7, 8).compId("000000007").compTyp("CC").retVal(0).build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 7, 9).compId("000000007").compTyp("CC").retVal(1).build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 8, -2).compId("000000005").compTyp("BC").build();
    sc.add(fm);

    fm = new FlwMapping.Builder("LC01", 9, -2).compId("000000005").compTyp("BC").build();
    sc.add(fm);

    /*   fm=new FlwMapping.Builder("LC01", -1, 1).build();
       sc.add(fm);
       
       fm=new FlwMapping.Builder("LC01", 1, 2).compId("000000001").compTyp("BC").build();
       sc.add(fm);
       
       fm=new FlwMapping.Builder("LC01", 2, 3).compId("000000002").compTyp("BC").build();
       sc.add(fm);
       
       fm=new FlwMapping.Builder("LC01", 3, 4).compId("000000003").compTyp("BC").build();
       sc.add(fm);
       
       fm=new FlwMapping.Builder("LC01", 4, 5).compId("000000004").compTyp("CC").retVal(0).build();
       sc.add(fm);
       
       fm=new FlwMapping.Builder("LC01", 4, 6).compId("000000004").compTyp("CC").retVal(1).build();
       sc.add(fm);
       
       fm=new FlwMapping.Builder("LC01", 5, -2).compId("000000005").compTyp("BC").build();
       sc.add(fm);
       
       fm=new FlwMapping.Builder("LC01", 6, -2).compId("000000006").compTyp("BC").build();
       sc.add(fm);
    */
    fm = new FlwMapping.Builder("LC01", -2).build();
    sc.add(fm);
    return sc;
  }

}
