package com.brilliance.ccbank.srcipt.core;

import java.util.List;

import org.slf4j.Logger;

import com.brilliance.ccbank.srcipt.parser.DbTokenParser;
import com.brilliance.ccbank.srcipt.parser.TextTokenParser;
import com.brilliance.ccbank.srcipt.parser.TokenParser;
import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.util.LogUtil;

public class ScriptParser
{
  private static Logger logger = LogUtil.getLogger("ccbank_scriptparser");

  private ScriptParser()
  {
    //阻止其构造对象
  }

  public static List<IAbsDef> textParse(String script, String charset)
      throws Exception
  {
    TokenParser parser = new TextTokenParser(script, charset, logger);
    parser.parse();
    return parser.getExecuteList();
  }

  public static List<IAbsDef> dbParse(List<FlwMapping> scripts, String charset)
      throws Exception
  {
    TokenParser parser = new DbTokenParser(scripts, charset, logger);
    parser.parse();
    return parser.getExecuteList();
  }
}
