package com.brilliance.ccbank.srcipt.core;

import java.util.Vector;

public enum ScriptType
{
  BEGIN("-1"), 
  CALL("CALL"),
  IF("IF"), 
  ELSEIF("ELSEIF"),
  ELSE("ELSE"), 
  VALIDATOR("VALIDATOR"),
  WHILE("WHILE"),
  BREAK("BREAK"),
  CONTINUE("CONTINUE"),
  ENDWHILE("ENDWHILE"),
  ENDIF("ENDIF"),
  END("-2");

  public final String TYPE_CODE;

  private ScriptType( String code )
  {
    this.TYPE_CODE = code;
  }

  @Override
  public String toString()
  {
    return TYPE_CODE;
  }

  /**
   * 命令支持大小写忽略
   * @param scripttype 脚本命令类型
   * @return
   */
  public boolean eq(String command)
  {
    return TYPE_CODE.equals(command.toUpperCase());
  }

  /**
   * 检测该命令是否包含'END'的字样，如果是则返回true。<br/>命令支持大小写忽略
   * @param command
   * @return
   */
  public static boolean isEnd(String command){
    return VariousEnd.contains(command.toUpperCase());
  }
  
  private static Vector<String> VariousEnd=new Vector<String>(2);
  
  static{
    for (ScriptType type : values()){
      if(type.TYPE_CODE.contains("END"))
        VariousEnd.add(type.TYPE_CODE);
    }
    VariousEnd.add("END");
  }
}
