package com.brilliance.ccbank.srcipt.reader;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import com.brilliance.eibs.util.StringUtil;

/**
 * 脚本阅读器
 * @author weicong
 *
 */
public class TextScriptReader
    extends ScriptReader
{
  private BufferedReader bufferdReader;

  public TextScriptReader( String rawscript, String charset )
      throws IOException
  {
    if (StringUtil.isEmpty(charset))
      charset = getCharset();
    InputStream is = new ByteArrayInputStream(rawscript.getBytes(charset));
    BufferedReader br = new BufferedReader(new InputStreamReader(new BufferedInputStream(is), charset));
    this.bufferdReader = br;
  }

  @Override
  public String readScriptLine()
      throws Exception
  {
    while ((scriptline = readLine()) != null)
    {
      if (StringUtil.isEmpty(scriptline) || scriptline.startsWith("#"))
      {
        continue;
      }
      return scriptline;
    }
    return null;
  }

  @Override
  public String readLine()
      throws Exception
  {
    if ((scriptline = bufferdReader.readLine()) != null)
    {
      return scriptline.trim();
    }
    return null;
  }

}
