package com.brilliance.eibs.factory.parser.impl;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections.map.CaseInsensitiveMap;

import com.brilliance.eibs.core.exception.InterfaceException;
import com.brilliance.eibs.core.service.instance.plugin.JdbcExecutor;

/**
 * @author ge
 * 数据库相关查询、更新操作，暂规定不做业务处理
 * **/
public class DbSource
{

  SessionFactory dbSource;

  public DbSource( SessionFactory dbSource )
  {
    this.dbSource = dbSource;
  }

  public List<Map<String, Object>> getErroCode(Object[] pars)
  {
    final String sql = "SELECT * FROM T_ERRCOD";
    return Query(sql, pars);
  }

  public List<Map<String, Object>> getCodeTables(Object[] pars)
  {
    final String sql = "SELECT * FROM T_CODTBL";
    return Query(sql, pars);
  }

  //

  public void close()
  {
    JdbcExecutor jdbcExecutor = null;
    try
    {
      jdbcExecutor = dbSource.getJdbcExecutor();
      if (!jdbcExecutor.isClosed())
      {
        jdbcExecutor.close();
      }
    }
    catch (Exception e)
    {
      throw new InterfaceException("01503", e);
    }
    finally
    {
      jdbcExecutor = null;
    }
  }

  private List<Map<String, Object>> Query(final String sql, final Object[] pars)
  {
    JdbcExecutor executor = null;
    try
    {
      executor = dbSource.getJdbcExecutor();
      List<Map<String, Object>> retList = new ArrayList<Map<String, Object>>();
      List<Map<String, Object>> list = executor.executeQuery(sql, pars);
      //键值对中的Key全部转换成小写，便于统一
      for (int i = 0; i < list.size(); i++)
      {
        Map<String, Object> map = list.get(i);
        Map<String, Object> retMap = new CaseInsensitiveMap(map);
        retList.add(retMap);
      }
      return retList;
      // return executor.executeQuery(sql, pars);
    }
    catch (Exception e)
    {
      try
      {
        if (executor != null)
          executor.close();
        executor = null;
      }
      catch (SQLException e1)
      {
        throw new InterfaceException("01503", e1);
      }
      throw new InterfaceException("01502", e);
    }
    finally
    {
      try
      {
        if (executor != null)
        {
          //          executor.close();
          executor.closeWithoutConn();
          executor = null;
        }
      }
      catch (SQLException e1)
      {
        throw new InterfaceException("01503", e1);
      }
    }
  }

}
