package com.brilliance.convert;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;

public class TD2BDScript {
	public static final String ENCODING = "UTF-8";
	public static List<String> varList = new ArrayList<String>();
	public static List<String> allVars = new ArrayList<String>();

	public static List<String> errors = new ArrayList<String>();

	public static void main(String[] args) throws FileNotFoundException {

		// generate("d:/source", "d:/dest");
		generate("d:/s", "d:/s1");
	}

	/**
	 * @srcPath TD script目录
	 * @destPath BD script目录
	 * **/
	public static void generate(String srcPath, String destPath) throws FileNotFoundException {

		File srcFile = new File(srcPath);
		if (!new File(destPath).exists())
			new File(destPath).mkdirs();
		for (File f : srcFile.listFiles()) {
			varList.clear();
			allVars.clear();
			System.out.println("srcPath=" + f.getName());
			String str = scriptOfTd2Bd(f);
			FileOutputStream fos = null;
			try {

				fos = new FileOutputStream(new File(destPath, f.getName()));
				IOUtils.write(str, fos);

			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();

			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				errors.add(f.getName());

			} finally {
				IOUtils.closeQuietly(fos);
			}
		}

	}

	public static boolean isVar(String str) {
		Pattern pt = Pattern.compile(VAR);
		// 然后使用Matcher来对比目标字符串与上面解释得结果
		Matcher mt = pt.matcher(str);

		while (mt.find()) {
			return true;
		}
		return false;
	}

	public static String handleVar(String str, boolean add) {
		StringBuilder sb = new StringBuilder(str);
		// 首先,使用Pattern解释要使用的正则表达式，其中^表是字符串的开始，$表示字符串的结尾。
		Pattern pt = Pattern.compile(VAR);
		// 然后使用Matcher来对比目标字符串与上面解释得结果
		Matcher mt = pt.matcher(str);

		while (mt.find()) {
			String findStr = mt.group();

			if (!varList.contains(findStr)) {
				varList.add(findStr);
				if (add) {
					// newList.add("String " + findStr.substring(1) +
					// " =\"\" ;");
					allVars.add("String " + findStr.substring(1) + " =\"\" ;");
				}

			}
			int start = mt.start();
			int end = mt.end();
			// System.out.println(mt.start());
			// System.out.println("find=" + findStr);
			// System.out.println(mt.end());
			sb = sb.replace(start, start + 1, " ");

		}
		// newList.add(sb.toString());

		return sb.toString();

	}

	public static String scriptOfTd2Bd(File f) {
		List<String> handleList = new ArrayList<String>();
		FileInputStream fis = null;
		try {
			fis = new FileInputStream(f);
			List<String> list = IOUtils.readLines(fis, ENCODING);
			for (int i = 0; i < list.size(); i++) {
				String str = list.get(i);
				if (!StringUtils.isEmpty(str.trim())) {
					str = str.trim();
					str = str.replace("Then", "then");
					str = str.replace("THEN", "then");
					handleList.add(str);
				}
			}

		} catch (Exception e) {
			e.printStackTrace();

		} finally {
			IOUtils.closeQuietly(fis);
		}
		return convertList(handleList);
	}

	public static String IF = "if ";
	public static String THEN = "then";
	public static String ENDIF = "endif";
	public static String ELSE = "else";
	public static String FOR = "for ";
	public static String NEXT = "next";
	public static String NEXT_BLANK = "next ";
	public static String WHILE = "while ";
	public static String DO = "do";
	public static String WEND = "wend";
	public static String SWITCHEND = "end select";
	public static String SWITCHCASE = "select case";
	public static String CASE = "case ";

	public static String TO = "to";
	public static String LEFTKH = "{";
	public static String RIGHTKH = "}";
	public static String VAR = "\\$[0-9a-zA-Z_]+";

	public static String convertList(List<String> handleList) {
		List<String> newList = new ArrayList<String>();
		try {
			for (int i = 0; i < handleList.size(); i++) {
				String str = handleList.get(i);
				str = str.replace("Visible(", "Platform.visible(");
				str = str.replace("Invisible(", "Platform.invisible(");
				str = str.replace("Disable(", "Platform.disable(");
				str = str.replace("Enable(", "Platform.enable(");

				if (str.startsWith(LEFTKH)) {
					newList.add("/**");
					while (true) {
						i++;

						if (i >= handleList.size() || handleList.get(i).equals(RIGHTKH)) {
							newList.add("**/");
							break;
						}
						newList.add(handleList.get(i));

					}
				} else if (str.startsWith(FOR)) {
					int toPos = str.indexOf(TO);
					String preCondition = str.substring(FOR.length(), toPos);
					String maxStr = str.substring(toPos + TO.length()).trim();
					String[] preConditions = preCondition.split("=");
					StringBuilder sbBuilder = new StringBuilder();
					String var = preConditions[0].trim();
					sbBuilder.append(FOR + "(int ").append(var + "=(" + (preConditions[1].trim() + " - 1") + ");");
					sbBuilder.append(var + "<" + maxStr + ";").append(var + "++)").append("{");
					newList.add(handleVar(sbBuilder.toString(), false));

				} else if (str.equals(NEXT) || str.startsWith(NEXT_BLANK) || str.equals(ENDIF) || str.equals(WEND) || str.equals(SWITCHEND)) {
					newList.add("}");
				} else if (str.startsWith(WHILE)) {
					str = handleVar(str, true);
					String whileCondition = str.substring(WHILE.length(), str.length() - DO.length());
					str = WHILE + "(" + whileCondition + "){";
					newList.add(str);
				} else if (str.startsWith(SWITCHCASE)) {
					str = handleVar(str, true);
					str = "switch (" + str.substring(SWITCHCASE.length()) + ") {";
					newList.add(str);
				} else if (str.startsWith(CASE)) {
					str = handleVar(str, true);
					str = str + " : ";
					newList.add(str);

					while (true) {
						i++;
						String tmp = handleList.get(i);
						if (tmp.equals(SWITCHEND)) {
							i--;
							break;
						}
						tmp = handleVar(tmp, true);
						if (tmp.startsWith(CASE)) {
							newList.add("break;");
						}
						newList.add(tmp + ":");

					}
				}

				else if (str.startsWith(IF)) {
					str = handleVar(str, true);
					// newList.add(str);
					StringBuilder sb = new StringBuilder();
					int a = str.indexOf(IF);
					int b = str.lastIndexOf(THEN);
					String c = str.substring(IF.length(), b);
					sb.append(IF).append("(").append(c).append("){");
					String ifstr = sb.toString();
					ifstr = ifstr.replace("not IsEmpty", "!Platform.isEmpty");
					ifstr = ifstr.replace("IsEmpty", "Platform.isEmpty");
					ifstr = ifstr.replace(" or ", " || ");
					ifstr = ifstr.replace(" and ", " && ");
					ifstr = ifstr.replace(" = \"", ".equals(\"");
					ifstr = ifstr.replace("\" ", "\")");
					// ifstr = ifstr.replace(" AND ", "Platform.isEmpty");
					newList.add(ifstr);
				} else if (str.equals(ELSE)) {
					newList.add("} else {");
				} else if (str.startsWith("#")) {
					str = str.replace("#", "//");
					newList.add(str);
				}

				else if (isVar(str)) {
					newList.add(handleVar(str, true) + ";");
				} else {
					newList.add(str + ";");
				}

			}
			newList.addAll(1, allVars);
		} catch (Exception e) {

		}
		StringBuffer sb = new StringBuffer();
		for (String str : newList) {
			sb.append(str + "\r\n");
		}
		return sb.toString();
	}
}
