package com.brilliance.ext.gd.threadpool;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;

import org.apache.commons.io.IOUtils;

import com.brilliance.eibs.core.threadpool.ThreadPoolFactory;

public class ThreadPoolInfoUtil {

	private static String SPT = "#";
	private static String ServerName = "be-dea:";
	private static String LineSplit = "\n";

	// 获取线程数量信息
	public static void getActiveCount(String path) throws Exception {
		List<String> list = new ArrayList<String>();
		Map<String, ExecutorService> excutorServiceMap = ThreadPoolFactory.getExcutorInfo();
		for (String threadPoolName : excutorServiceMap.keySet()) {
			ThreadPoolExecutor tpe = (ThreadPoolExecutor) excutorServiceMap.get(threadPoolName);
			list.add(tpe.getActiveCount() + SPT + ServerName + threadPoolName + SPT + "0" + SPT + "Null" + SPT + tpe.getMaximumPoolSize() + SPT
					+ "ThreadPool" + SPT + "0" + SPT + "Null");

		}
		File f = new File(path);
		if (!f.getParentFile().exists()) {
			f.getParentFile().mkdirs();
		}
		FileOutputStream fos = new FileOutputStream(f);
		IOUtils.writeLines(list, LineSplit, fos);
		IOUtils.closeQuietly(fos);
	}

	// 获取队列信息
	public static void getQueueSize(String path) throws Exception {
		List<String> list = new ArrayList<String>();
		Map<String, ExecutorService> excutorServiceMap = ThreadPoolFactory.getExcutorInfo();
		for (String threadPoolName : excutorServiceMap.keySet()) {
			ThreadPoolExecutor tpe = (ThreadPoolExecutor) excutorServiceMap.get(threadPoolName);
			list.add(tpe.getQueue().size() + SPT + ServerName + threadPoolName + SPT + "0" + SPT + "Null" + SPT
					+ (tpe.getQueue().size() + tpe.getQueue().remainingCapacity()) + SPT + "ThreadPool" + SPT + "0" + SPT + "Null");

		}
		File f = new File(path);
		if (!f.getParentFile().exists()) {
			f.getParentFile().mkdirs();
		}
		FileOutputStream fos = new FileOutputStream(f);
		IOUtils.writeLines(list, LineSplit, fos);
		IOUtils.closeQuietly(fos);
	}
}
