package com.brilliance.ext.util;

import java.io.File;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections.map.LinkedMap;

import com.brilliance.eibs.el.CommonFunctionUtils;

public class ApiUtil {

	public static List<Map<String, Object>> parseApiStr(String str) {

		List<Map<String, Object>> list = new LinkedList<Map<String, Object>>();

		String sec = "^";
		String secsplit = "\\" + sec;
		String one = "#";

		String strs[] = str.split(one);
		for (int i = 0; i < strs.length; i++) {
			Map map = new LinkedMap();
			if (!strs[i].contains("^")) {
				String keyv[] = strs[i].split("=");
				map.put(keyv[0], keyv[1]);
			} else {
				String sttrs[] = strs[i].split(secsplit);
				for (int j = 0; j < sttrs.length; j++) {
					String keyv[] = sttrs[j].split("=");
					if (keyv.length != 1)
						map.put(keyv[0], keyv[1]);
					else
						map.put(keyv[0], "");
				}

			}
			list.add(map);
		}
		return list;

	}

	// 发送今天的相关日志报文
	public static List<String> getFilePath(String dirpath) {
		List<String> list = new ArrayList<String>();
		File f = new File(dirpath);
		String[] listFile = f.list();
		for (int i = 0; i < listFile.length; i++) {
			String now = CommonFunctionUtils.formatNow("yy-MM-dd");
			// 文件名的1-9位
			String fileHead = listFile[i].substring(1, 9);
			if (fileHead.equals(now)) {
				list.add(listFile[i]);
			}
		}
		return list;
	}

	public static List<String> sendpack(List<String> list, String nowdate, int set) throws ParseException {

		List<String> liststr = new ArrayList<String>();
		Date date = CommonFunctionUtils.dateAdd(CommonFunctionUtils.parseDate(nowdate, "MM-dd HH:mm:ss"), 1, set);
		String logdate = CommonFunctionUtils.format(date, "MM-dd HH:mm:ss");
		// System.out.println("logdate=" + logdate);
		for (String logstr : list) {
			String loghead = logstr.substring(1, 15);
			// System.out.println(loghead);
			if (loghead.compareTo(logdate) >= 0 && loghead.compareTo(nowdate) <= 0) {
				String keys = "所有回报:";
				if (logstr.contains(keys))
					liststr.add(logstr.substring(logstr.indexOf(keys) + keys.length()));
			}
		}
		return liststr;
	}

	public static void main(String[] args) throws ParseException {
		List<String> list = new ArrayList<String>();
		list.add("[09-02 19:28:57]:所有回报:0857APINAME=onRecvDeferQuotation#DATATYPE=TDeferQuotation^instID=Ag(T+D)^name=白银延期^lastSettle=3362.000000^lastClose=3355.000000^open=3352.000000^high=3365.000000^low=3339.000000^last=3362.000000^close=0.000000^settle=0.000000^bid1=3361.000000^bidLot1=899^bid2=3360.000000^bidLot2=22^bid3=3359.000000^bidLot3=17^bid4=3358.000000^bidLot4=98^bid5=3357.000000^bidLot5=33^ask1=3362.000000^askLot1=164^ask2=3363.000000^askLot2=257^ask3=3364.000000^askLot3=335^ask4=3365.000000^askLot4=3701^ask5=3366.000000^askLot5=917^volume=334752^weight=334752.000000^highLimit=3630.000000^lowLimit=3093.000000^Posi=5403802^upDown=0.000000^upDownRate=0.000000^turnOver=1123360354.000000^average=3355.000000^quoteDate=20160328^quoteTime=02:25:23^sequenceNo=36202^#DATATYPE=TTRspMsg^Flag=L^RspCode=RSP000000^RspMsg=交易成功^#DATATYPE=String^val=^#");
		list.add("[09-02 19:28:58]:所有回1报:0858APINAME=onRecvDeferQuotation#DATATYPE=TDeferQuotation^instID=Ag(T+D)^name=白银延期^lastSettle=3362.000000^lastClose=3355.000000^open=3352.000000^high=3365.000000^low=3339.000000^last=3362.000000^close=0.000000^settle=0.000000^bid1=3361.000000^bidLot1=899^bid2=3360.000000^bidLot2=22^bid3=3359.000000^bidLot3=17^bid4=3358.000000^bidLot4=98^bid5=3357.000000^bidLot5=33^ask1=3362.000000^askLot1=164^ask2=3363.000000^askLot2=257^ask3=3364.000000^askLot3=335^ask4=3365.000000^askLot4=3701^ask5=3366.000000^askLot5=917^volume=334752^weight=334752.000000^highLimit=3630.000000^lowLimit=3093.000000^Posi=5403802^upDown=0.000000^upDownRate=0.000000^turnOver=1123360354.000000^average=3355.000000^quoteDate=20160328^quoteTime=02:25:23^sequenceNo=36202^#DATATYPE=TTRspMsg^Flag=L^RspCode=RSP000000^RspMsg=交易成功^#DATATYPE=String^val=^#");
		list.add("[09-02 19:28:59]:所有回报:0859APINAME=onRecvDeferQuotation#DATATYPE=TDeferQuotation^instID=Ag(T+D)^name=白银延期^lastSettle=3362.000000^lastClose=3355.000000^open=3352.000000^high=3365.000000^low=3339.000000^last=3362.000000^close=0.000000^settle=0.000000^bid1=3361.000000^bidLot1=899^bid2=3360.000000^bidLot2=22^bid3=3359.000000^bidLot3=17^bid4=3358.000000^bidLot4=98^bid5=3357.000000^bidLot5=33^ask1=3362.000000^askLot1=164^ask2=3363.000000^askLot2=257^ask3=3364.000000^askLot3=335^ask4=3365.000000^askLot4=3701^ask5=3366.000000^askLot5=917^volume=334752^weight=334752.000000^highLimit=3630.000000^lowLimit=3093.000000^Posi=5403802^upDown=0.000000^upDownRate=0.000000^turnOver=1123360354.000000^average=3355.000000^quoteDate=20160328^quoteTime=02:25:23^sequenceNo=36202^#DATATYPE=TTRspMsg^Flag=L^RspCode=RSP000000^RspMsg=交易成功^#DATATYPE=String^val=^#");
		String now = CommonFunctionUtils.formatNow("MM-dd HH:mm:ss");

		System.out.println(sendpack(list, "09-02 19:28:59", -1));
	}
}
