package com.brilliance.swift;

import com.brilliance.eibs.util.LogUtil;
import org.slf4j.Logger;

import java.io.IOException;
import java.util.Map;

public class AbstractMTPackMessage {
    static final Logger log = LogUtil.getOrCreateLogger("packageerror");
    protected final static String SINGLEESCAPE = "/";
    protected final static String ESCAPE = "//";

    protected static String getLogicalTerminalAddress(String bic, String field) {
        if (bic == null) {
            return null;
        }
        if ((bic.length() == 8) || (bic.length() == 11) || (bic.length() == 12)) {
            if (bic.length() == 11) {
                if ("1".equals(field)) {
                    return bic.substring(0, 8) + "A" + bic.substring(8, 11);
                } else {
                    return bic.substring(0, 8) + "X" + bic.substring(8, 11);
                }
            }
            if (bic.length() == 8) {
                if ("1".equals(field)) {
                    return bic.substring(0, 8) + "AXXX";
                } else {
                    return bic.substring(0, 8) + "XXXX";
                }
            }
            return bic;
        }
        return null;
    }

    protected static String getBicByLogicalTerminalAddress(String bic) {
        if (bic != null && bic.length() > 11)
            return bic.substring(0, 8) + bic.substring(9, 12);
        return bic;
    }

    // protected static String getLogicalTerminalAddress(String bic) {
    // if (bic == null)
    // return null;
    //
    // if ((bic.length() == 8) || (bic.length() == 11) || (bic.length() == 12))
    // {
    // if (!Util.IS_USING_TEST_BIC) {
    // if (bic.length() == 11)
    // return bic.substring(0, 8) + "X" + bic.substring(8, 11);
    // if (bic.length() == 8) {
    // return bic.substring(0, 8) + "XXXX";
    // }
    // return bic;
    // }
    //
    // if (bic.length() == 11)
    // return bic.substring(0, 7) + "0X" + bic.substring(8, 11);
    // if (bic.length() == 8) {
    // return bic.substring(0, 7) + "0XXXX";
    // }
    // return bic.substring(0, 7) + "0" + bic.substring(8);
    // }
    //
    // return null;
    // }

    protected static boolean isNULL(Object obj) {
        return obj == null;
    }

    public static boolean isNotEmpty(Object content) {
        if (content != null && !content.toString().trim().equals(""))
            return true;
        else
            return false;
    }

    protected static String exchangeMoney(String samt) {
        if (samt.indexOf(".") > 0) {
            if (samt.indexOf("JPY") != -1) {
                samt = samt.substring(0, samt.indexOf(".") + 1);
            }
            return samt.replace(".", ",");
        } else {
            return samt + ",";
        }

    }

    protected static void packDymicFieldAd(SwtBufferedWriter bw, String field,
                                           @SuppressWarnings("rawtypes") Map msgMap) throws IOException {
        String fieldval = (String) msgMap.get(field);
        String fieldw = ":" + field + ":";
        if (isNotEmpty(fieldval)) {
            bw.write(fieldw);
            bw.write(fieldval);
            bw.newLine();
        } else {
            boolean flag = false;
            String fieldONE = (String) msgMap.get(field + "ONE");
            String fieldTWO = (String) msgMap.get(field + "TWO");

            if (isNotEmpty(fieldTWO)) {
                if (isNotEmpty(fieldONE)) {
                    flag = true;
                    if (!fieldONE.startsWith(SINGLEESCAPE)) {
                        fieldONE = SINGLEESCAPE + fieldONE;
                    }
                    bw.write(fieldw);
                    bw.write(fieldONE);
                    bw.newLine();
                }
                String content = fieldTWO.replaceAll("[\r\n]{1,2}",
                        SwtBufferedWriter.NEW_LINE);
                if (!flag) {
                    bw.write(fieldw);
                }
                bw.write(content);
                bw.newLine();
            }
        }
    }

    protected static void packDymicField(SwtBufferedWriter bw, String token,
                                         String[] content) throws IOException {
        if (content == null)
            return;
        if (isNotEmpty(token)) {
            // token = ESCAPE + token.substring(0, 1) + ESCAPE
            // + token.substring(1);
            if (!token.startsWith(SINGLEESCAPE)) {
                token = SINGLEESCAPE + token;
            }
            for (String cot : content) {
                String[] tmp = cot.split("\\^");
                if (isNotEmpty(tmp[1])) {
                    bw.write(tmp[0]);
                    bw.write(token);
                    bw.newLine();
                    if (tmp[0].contains("D") || tmp[0].contains("K")) {
                        packMultiLineField(bw, tmp[1], Integer.parseInt(tmp[2]));
                    } else {
                        bw.write(tmp[1]);
                        bw.newLine();
                    }
                    break;
                }
            }
        } else {
            for (String cot : content) {
                String[] tmp = cot.split("\\^");
                if (isNotEmpty(tmp[1])) {
                    bw.write(tmp[0]);
                    if (tmp[0].contains("D") || tmp[0].contains("K")) {
                        packMultiLineField(bw, tmp[1], Integer.parseInt(tmp[2]));
                    } else {
                        bw.write(tmp[1]);
                        bw.newLine();
                    }
                    break;
                }
            }
        }
    }

    protected static void packMultiLineField(SwtBufferedWriter bw,
                                             String content, int max) throws IOException {
        packMultiLineField(bw, content, max, false);
    }

    protected static void packMultiLineField(SwtBufferedWriter bw,
                                             String content, int max, boolean isescape) throws IOException {
        content = content.replaceAll("[\r\n]{1,2}", SwtBufferedWriter.NEW_LINE);
        bw.write(content);
        bw.newLine();
    }

    protected static void handleMultiLineField(SwtBufferedWriter bw,
                                               String content, int max, boolean isescape) throws IOException {
        int index = 0;
        int totalleft = 0;
        int len = content.length();
        while (index < len) {
            int left = 0;
            totalleft = len - index;
            if (totalleft >= max)
                left = max;
            else {
                left = totalleft;
            }
            if (isescape) {
                bw.write(ESCAPE + content.substring(index, index + left));
            } else {
                bw.write(content.substring(index, index + left));
            }
            bw.newLine();
            index += max;
        }
    }

    @SuppressWarnings("rawtypes")
    protected static void pack11aMessage(SwtBufferedWriter bw, Map msgMap,
                                         String type) {
        try {
            if (msgMap.get("SWT_MSG_TYP") != null
                    && !"".equals(msgMap.get("SWT_MSG_TYP"))) {
                bw.write(":11" + type + ":");
                bw.write((String) msgMap.get("SWT_MSG_TYP"));
                bw.newLine();
            }
            if (msgMap.get("SWT_MSG_SENT_DATE") != null
                    && !"".equals(msgMap.get("SWT_MSG_SENT_DATE"))) {
                String date = (String) msgMap.get("SWT_MSG_SENT_DATE");
                date = date.substring(2);
                bw.write(date);
                bw.newLine();
            }
            if (msgMap.get("SWT_MEG_NO") != null
                    && !"".equals(msgMap.get("SWT_MEG_NO"))) {
                bw.write((String) msgMap.get("SWT_MEG_NO"));
                bw.newLine();
            }
        } catch (IOException e) {
            log.error("tag11a:", e);
        }
    }

    protected static String changeAddr(Object adr) {
        if (adr == null)
            return "";
        int pos = 35;
        StringBuilder buf = new StringBuilder((String) adr);
        while (pos < buf.length()) {
            buf.insert(pos, "\r\n//");
            pos = pos + 35 + 2;
        }
        return buf.toString().replaceAll("[ ]+(?=\\r\\n)", "").toUpperCase();
    }

    protected static String parseHexStr2Byte(String hexStr) {
        if (hexStr.length() < 1)
            return null;
        byte[] result = new byte[hexStr.length() / 2];
        for (int i = 0; i < hexStr.length() / 2; i++) {
            int high = Integer.parseInt(hexStr.substring(i * 2, i * 2 + 1), 16);
            int low = Integer.parseInt(hexStr.substring(i * 2 + 1, i * 2 + 2),
                    16);
            result[i] = (byte) (high * 16 + low);
        }
        return new String(result);
    }

    public static String getNewLine() {
        return SwtBufferedWriter.NEW_LINE;
    }

    public static void main(String[] args) {
        // System.err.println(parseHexStr2Byte("03"));
//		System.err.print(parseHexStr2Byte("5e5b"));
        System.err.print(exchangeMoney("11JPY.111"));
    }
}
