package com.brilliance.swift;

import java.io.IOException;
import java.io.StringWriter;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.apache.commons.io.IOUtils;

@SuppressWarnings("rawtypes")
public class MTPackMessage extends AbstractMTPackMessage {

	public static String gener103Message(Map msgMap) {
		StringWriter sw = null;
		SwtBufferedWriter bw = null;
		try {
			sw = new StringWriter();
			bw = new SwtBufferedWriter(sw);

			bw.write("{1:F01");
			String sndbic = (String) msgMap.get("SNDBIC");
			if ((sndbic != null) && (!"".equals(sndbic)))
				bw.write(getLogicalTerminalAddress(sndbic,"1") + "0000000000");
			bw.write("}");

			bw.write("{2:I103");
			String rcvbic = (String) msgMap.get("RCVBIC");
			bw.write(String.format("%s",
					new Object[] { getLogicalTerminalAddress(rcvbic,"2") }));
			bw.write("N");
			bw.write("}");

			bw.write("{4:");
			bw.newLine();

			bw.write(":20:");
			String ref20 = (String) msgMap.get("20");
			if (ref20 == null) {
				log.error("20域为空");
				return "";
			}

			bw.write(ref20);
			bw.newLine();

			String _23B = (String) msgMap.get("23B");
			if ((_23B != null) && (!"".equals(_23B))) {
				bw.write(":23B:");
				bw.write(_23B);
				bw.newLine();
			} else {
				bw.write(":23B:CRED");
				bw.newLine();
			}

			bw.write(":32A:");
			bw.write(exchangeMoney((String) msgMap.get("32A")));
			bw.newLine();

			String _33B = (String) msgMap.get("33B");
			if ((_33B != null) && (!"".equals(_33B))) {
				bw.write(":33B:");
				bw.write(exchangeMoney(_33B));
				bw.newLine();
			}

			String _36 = (String) msgMap.get("36");
			if ((_36 != null) && (!"".equals(_36))) {
				bw.write(":36:");
				bw.write(exchangeMoney(_36));
				bw.newLine();
			}

			packDymicFieldAd(bw, "50K", msgMap);
			
			packDymicFieldAd(bw, "51A", msgMap);

			String _52A = (String) msgMap.get("52A");
			if ((_52A != null) && (!"".equals(_52A))) {
				bw.write(":52A:");
				bw.write(_52A);
				bw.newLine();
			} else {
				String _52D = (String) msgMap.get("52D");
				if ((_52D != null) && (!"".equals(_52D))) {
					bw.write(":52D:");
					bw.write(_52D);
					bw.newLine();
				}

			}

			packDymicFieldAd(bw, "53A", msgMap);
			packDymicFieldAd(bw, "53D", msgMap);
			packDymicFieldAd(bw, "54A", msgMap);
			packDymicFieldAd(bw, "54D", msgMap);

			packDymicFieldAd(bw, "55A", msgMap);
			packDymicFieldAd(bw, "55D", msgMap);

			packDymicFieldAd(bw, "56A", msgMap);
			packDymicFieldAd(bw, "56D", msgMap);
			packDymicFieldAd(bw, "57A", msgMap);
			packDymicFieldAd(bw, "57D", msgMap);

//			String _59ONE = (String) msgMap.get("59ONE");
//			if ((_59ONE != null) && (!"".equals(_59ONE))) {
//				packDymicField(bw, _59ONE, new String[] { ":59:^"
//						+ (String) msgMap.get("59TWO") + "^35" });
//			} else {
//				String _59AONE = (String) msgMap.get("59AONE");
//				if ((_59AONE != null) && (!"".equals(_59AONE))) {
//					packDymicField(bw, _59AONE, new String[] { ":59A:^"
//							+ (String) msgMap.get("59ATWO") + "^11" });
//				}
//			}
			packDymicFieldAd(bw, "59", msgMap);

			packDymicFieldAd(bw, "70", msgMap);

			String _71A = (String) msgMap.get("71A");
			if ((_71A != null) && (!"".equals(_71A))) {
				bw.write(":71A:");
				bw.write(_71A);
				bw.newLine();
			}

			String _71F = (String) msgMap.get("71F");
			if ((_71F != null) && (!"".equals(_71F))) {
				bw.write(":71F:");
				bw.write(exchangeMoney(_71F));
				bw.newLine();
			}
			String _71G = (String) msgMap.get("71G");
			if ((_71G != null) && (!"".equals(_71G))) {
				bw.write(":71G:");
				bw.write(exchangeMoney(_71G));
				bw.newLine();
			}

			String _72 = (String) msgMap.get("72");
			if ((_72 != null) && (!"".equals(_72))) {
				packMultiLineField(bw, ":72:" + _72, 35, true);
			}
			bw.write("-}");
			bw.flush();
			return sw.toString();
		} catch (Exception e) {
			log.error("gener103 error:", e);
			return "";
		} finally {
			IOUtils.closeQuietly(bw);
		}
	}

	public static String gener202Message(Map msgMap) {
		StringWriter sw = null;
		SwtBufferedWriter bw = null;
		try {
			sw = new StringWriter();
			bw = new SwtBufferedWriter(sw);

			bw.write("{1:F01");
			String sndbic = (String) msgMap.get("SNDBIC");
			if ((sndbic != null) && (!"".equals(sndbic)))
				bw.write(getLogicalTerminalAddress(sndbic,"1") + "0000000000");
			bw.write("}");

			bw.write("{2:I202");
			String rcvbic = (String) msgMap.get("RCVBIC");
			bw.write(String.format("%s",
					new Object[] { getLogicalTerminalAddress(rcvbic,"2") }));
			bw.write("N");
			bw.write("}");

			bw.write("{4:");
			bw.newLine();

			bw.write(":20:");
			String ref20 = (String) msgMap.get("20");
			if (ref20 == null) {
				log.error("20域为空");
				return "";
			}

			bw.write(ref20);
			bw.newLine();

			bw.write(":21:");
			String ref21 = (String) msgMap.get("21");
			if (ref21 == null) {
				log.error("21域为空");
				return "";
			}

			bw.write(ref21);
			bw.newLine();

			String _13C = (String) msgMap.get("13C");
			if ((_13C != null) && (!"".equals(_13C))) {
				bw.write(":13C:");
				bw.write(_13C);
				bw.newLine();
			}

			bw.write(":32A:");
			bw.write(exchangeMoney((String) msgMap.get("32A")));
			bw.newLine();

			packDymicFieldAd(bw, "52A", msgMap);
			packDymicFieldAd(bw, "52D", msgMap);
			packDymicFieldAd(bw, "53A", msgMap);
			packDymicFieldAd(bw, "53D", msgMap);
			packDymicFieldAd(bw, "54A", msgMap);
			packDymicFieldAd(bw, "54D", msgMap);
			packDymicFieldAd(bw, "56A", msgMap);
			packDymicFieldAd(bw, "56D", msgMap);
			packDymicFieldAd(bw, "57A", msgMap);
			packDymicFieldAd(bw, "57D", msgMap);
			packDymicFieldAd(bw, "58A", msgMap);
			packDymicFieldAd(bw, "58D", msgMap);

			String _72 = (String) msgMap.get("72");
			if ((_72 != null) && (!"".equals(_72))) {
				packMultiLineField(bw, ":72:" + _72, 35, true);
			}
			bw.write("-}");
			bw.flush();
			return sw.toString();
		} catch (Exception e) {
			log.error("gener202 error:", e);
			return "";
		} finally {
			IOUtils.closeQuietly(bw);
		}
	}

	public static String gener202CovMessage(Map msgMap202, Map msgMap103) {
		StringWriter sw = null;
		SwtBufferedWriter bw = null;
		try {
			sw = new StringWriter();
			bw = new SwtBufferedWriter(sw);

			bw.write("{1:F01");
			String sndbic = (String) msgMap202.get("SNDBIC");
			if ((sndbic != null) && (!"".equals(sndbic)))
				bw.write(getLogicalTerminalAddress(sndbic,"1") + "0000000000");
			bw.write("}");

			bw.write("{2:I202");
			String rcvbic = (String) msgMap202.get("RCVBIC");
			bw.write(String.format("%s",
					new Object[] { getLogicalTerminalAddress(rcvbic,"2") }));
			bw.write("N");
			bw.write("}");

			bw.write("{3:{119:COV}}");

			bw.write("{4:");
			bw.newLine();

			bw.write(":20:");
			String ref20 = (String) msgMap202.get("20");
			if (ref20 == null) {
				log.error("20域为空");
				return "";
			}
			bw.write(ref20);
			bw.newLine();

			bw.write(":21:");
			String ref21 = (String) msgMap202.get("21");
			if (ref21 == null) {
				log.error("21域为空");
				return "";
			}
			bw.write(ref21);
			bw.newLine();

			bw.write(":32A:");
			bw.write(exchangeMoney((String) msgMap202.get("32A")));
			bw.newLine();

			packDymicFieldAd(bw, "52A", msgMap202);
			packDymicFieldAd(bw, "52D", msgMap202);
			packDymicFieldAd(bw, "53A", msgMap202);
			packDymicFieldAd(bw, "53D", msgMap202);
			packDymicFieldAd(bw, "54A", msgMap202);
			packDymicFieldAd(bw, "54D", msgMap202);
			packDymicFieldAd(bw, "56A", msgMap202);
			packDymicFieldAd(bw, "56D", msgMap202);
			packDymicFieldAd(bw, "57A", msgMap202);
			packDymicFieldAd(bw, "57D", msgMap202);
			packDymicFieldAd(bw, "58A", msgMap202);
			packDymicFieldAd(bw, "58D", msgMap202);

			String _72 = (String) msgMap202.get("72");
			if ((_72 != null) && (!"".equals(_72))) {
				packMultiLineField(bw, ":72:" + _72, 35, true);
			}
			packDymicFieldAd(bw, "50A", msgMap103);
			packDymicFieldAd(bw, "50K", msgMap103);
			packDymicFieldAd(bw, "50F", msgMap103);

			packDymicFieldAd(bw, "52A", msgMap103);
			packDymicFieldAd(bw, "52D", msgMap103);

			String _59ONE = (String) msgMap103.get("59ONE");
			if ((_59ONE != null) && (!"".equals(_59ONE))) {
				packDymicField(bw, _59ONE, new String[] { ":59:^"
						+ (String) msgMap103.get("59TWO") + "^35" });
			} else {
				String _59AONE = (String) msgMap103.get("59AONE");
				if ((_59AONE != null) && (!"".equals(_59AONE))) {
					packDymicField(bw, _59AONE, new String[] { ":59A:^"
							+ (String) msgMap103.get("59ATWO") + "^11" });
				}
			}

			packDymicFieldAd(bw, "70", msgMap103);
			String _72_103 = (String) msgMap103.get("72");
			if ((_72_103 != null) && (!"".equals(_72_103))) {
				packMultiLineField(bw, ":72:" + _72_103, 35, true);
			}

			String _33B = (String) msgMap103.get("33B");
			if ((_33B != null) && (!"".equals(_33B))) {
				bw.write(":33B:");
				bw.write(exchangeMoney(_33B));
				bw.newLine();
			}

			bw.write("-}");
			bw.flush();
			return sw.toString();
		} catch (Exception e) {
			log.error("gener202CovMessage error:", e);
			return "";
		} finally {
			IOUtils.closeQuietly(bw);
		}
	}

	public static String generN99Message(Map msgMap) {
		StringWriter sw = null;
		SwtBufferedWriter bw = null;
		String pcode = (String) msgMap.get("PCODE");
		try {
			sw = new StringWriter();
			bw = new SwtBufferedWriter(sw);

			bw.write("{1:F01");
			String sndbic = (String) msgMap.get("SNDBIC");
			if ((sndbic != null) && (!"".equals(sndbic)))
				bw.write(getLogicalTerminalAddress(sndbic,"1") + "0000000000");
			bw.write("}");

			bw.write("{2:I" + pcode.substring(0, 3));
			String rcvbic = (String) msgMap.get("RCVBIC");
			bw.write(String.format("%s",
					new Object[] { getLogicalTerminalAddress(rcvbic,"2") }));
			bw.write("N");
			bw.write("}");

			bw.write("{4:");
			bw.newLine();

			bw.write(":20:");
			String ref20 = (String) msgMap.get("20");
			if (ref20 == null) {
				log.error("20域为空");
				return "";
			}
			bw.write(ref20);
			bw.newLine();

			bw.write(":21:");
			String ref21 = (String) msgMap.get("21");
			if (ref21 == null) {
				log.error("21域为空");
				return "";
			}

			bw.write(ref21);
			bw.newLine();

			String ADDOPERATMSG = (String) msgMap.get("79");
			if ((ADDOPERATMSG != null) && (!"".equals(ADDOPERATMSG))) {
				bw.write(":79:");
				packMultiLineField(bw, ADDOPERATMSG, 50);
			}
			bw.write("-}");
			bw.flush();
			return sw.toString();
		} catch (Exception e) {
			log.error("generN99Message error:", e);
			return "";
		} finally {
			IOUtils.closeQuietly(bw);
		}
	}

	public static String gener292Message(Map msgMap) {
		StringWriter sw = null;
		SwtBufferedWriter bw = null;
		String pcode = (String) msgMap.get("PCODE");
		try {
			sw = new StringWriter();
			bw = new SwtBufferedWriter(sw);

			bw.write("{1:F01");
			String sndbic = (String) msgMap.get("SNDBIC");
			if ((sndbic != null) && (!"".equals(sndbic)))
				bw.write(getLogicalTerminalAddress(sndbic,"1") + "0000000000");
			bw.write("}");

			bw.write("{2:I" + pcode.substring(3, 6));
			String rcvbic = (String) msgMap.get("SWT_RECE_BANK_NO");
			bw.write(String.format("%s",
					new Object[] { getLogicalTerminalAddress(rcvbic,"2") }));
			bw.write("N");
			bw.write("}");

			bw.write("{4:");
			bw.newLine();

			bw.write(":20:");
			String ref20 = (String) msgMap.get("SEQNO");
			if (ref20 == null) {
				log.error("20域为空");
				return "";
			}

			bw.write(ref20);
			bw.newLine();

			bw.write(":21:");
			String ref21 = (String) msgMap.get("ORGSEQNO");
			if (ref21 == null) {
				log.error("21域为空");
				return "";
			}
			bw.write(ref21);
			bw.newLine();
			pack11aMessage(bw, msgMap, "S");
			String ADDOPERATMSG = (String) msgMap.get("ADDOPERATMSG");
			if ((ADDOPERATMSG != null) && (!"".equals(ADDOPERATMSG))) {
				bw.write(":79:");
				packMultiLineField(bw, ADDOPERATMSG, 50);
			}
			String ADD_INFO = (String) msgMap.get("ADD_INFO");
			if ((ADD_INFO != null) && (!"".equals(ADD_INFO))) {
				bw.write(ADD_INFO);
				bw.newLine();
			}
			bw.write("-}");
			bw.flush();
			return sw.toString();
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		} finally {
			IOUtils.closeQuietly(bw);
		}
	}

	public static String generN99or29NMessage(Map msgMap, String smhInr) {
		StringWriter sw = null;
		SwtBufferedWriter bw = null;
		String pcode = (String) msgMap.get("PCODE");
		try {
			sw = new StringWriter();
			bw = new SwtBufferedWriter(sw);

			bw.write("{1:F01");
			String sndbic = (String) msgMap.get("SNDBIC");
			if ((sndbic != null) && (!"".equals(sndbic)))
				bw.write(getLogicalTerminalAddress(sndbic,"1") + "0000000000");
			bw.write("}");

			bw.write("{2:I" + pcode.substring(0, 3));
			bw.write(String.format("%s",
					new Object[] { getLogicalTerminalAddress((String) msgMap
							.get("SWT_RECE_BANK_NO"),"2") }));
			bw.write("N");
			bw.write("}");

			bw.write("{4:");
			bw.newLine();

			bw.write(":20:");

			String ref20 = (String) msgMap.get("20");
			if (ref20 == null) {
				log.error("20域为空");
				return "";
			}
			bw.write(ref20);
			bw.newLine();

			bw.write(":21:");
			String ref21 = (String) msgMap.get("21");
			if (ref21 == null) {
				log.error("21域为空");
				return "";
			}
			bw.write(ref21);
			bw.newLine();

			if (("001199".equals(pcode)) || ("001999".equals(pcode))
					|| ("001299".equals(pcode))) {
				String ADDOPERATMSG = (String) msgMap.get("ADDOPERATMSG");
				if ((ADDOPERATMSG != null) && (!"".equals(ADDOPERATMSG))) {
					bw.write(":79:");
					packMultiLineField(bw, ADDOPERATMSG, 50);
				}
			} else if ("001292".equals(pcode)) {
				pack11aMessage(bw, msgMap, "S");
				String ADDOPERATMSG = (String) msgMap.get("ADDOPERATMSG");
				if ((ADDOPERATMSG != null) && (!"".equals(ADDOPERATMSG))) {
					bw.write(":79:");
					packMultiLineField(bw, ADDOPERATMSG, 50);
				}
				String ADD_INFO = (String) msgMap.get("ADD_INFO");
				if ((ADD_INFO != null) && (!"".equals(ADD_INFO))) {
					bw.write(ADD_INFO);
					bw.newLine();
				}
			} else if (("001295".equals(pcode)) || ("001296".equals(pcode))) {
				if ("001295".equals(pcode)) {
					String QUERYMSG = (String) msgMap.get("QUERYMSG");
					if ((QUERYMSG != null) && (!"".equals(QUERYMSG))) {
						bw.write(":75:");
						packMultiLineField(bw, QUERYMSG, 35);
					}
				} else {
					String REPLYINFO = (String) msgMap.get("REPLYINFO");
					if ((REPLYINFO != null) && (!"".equals(REPLYINFO))) {
						bw.write(":76:");
						packMultiLineField(bw, REPLYINFO, 35);
					}
				}
				String NARRATIVE = (String) msgMap.get("NARRATIVE");
				if ((NARRATIVE != null) && (!"".equals(NARRATIVE))) {
					bw.write(":77:");
					packMultiLineField(bw, NARRATIVE, 35);
				}
				pack11aMessage(bw, msgMap, "S");
				String ADDOPERATMSG = (String) msgMap.get("ADDOPERATMSG");
				if ((ADDOPERATMSG != null) && (!"".equals(ADDOPERATMSG))) {
					bw.write(":79:");
					packMultiLineField(bw, ADDOPERATMSG, 50);
				}
				String ADD_INFO = (String) msgMap.get("ADD_INFO");
				if ((ADD_INFO != null) && (!"".equals(ADD_INFO))) {
					bw.write(ADD_INFO);
					bw.newLine();
				}
			}

			bw.write("-}");
			bw.flush();
			log.info("swfit=" + sw.toString());
			return sw.toString();
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		} finally {
			IOUtils.closeQuietly(bw);
		}
	}

	public static String gener950Message(Map msgMap) {
		StringWriter sw = null;
		SwtBufferedWriter bw = null;
		try {
			sw = new StringWriter();
			bw = new SwtBufferedWriter(sw);

			bw.write("{1:F01");
			String sndbic = (String) msgMap.get("SNDBIC");
			if ((sndbic != null) && (!"".equals(sndbic)))
				bw.write(getLogicalTerminalAddress(sndbic,"1") + "0000000000");
			bw.write("}");

			bw.write("{2:I950");
			String rcvbic = (String) msgMap.get("RCVBIC");
			bw.write(String.format("%s",
					new Object[] { getLogicalTerminalAddress(rcvbic,"2") }));
			bw.write("N");
			bw.write("}");

			bw.write("{4:");
			bw.newLine();
			
			String ref20 = (String) msgMap.get("20");
			if (ref20 == null) {
				log.error("20域为空");
				return "";
			}
			bw.write(":20:");
			bw.write(ref20);
			bw.newLine();

			
			String ref25 = (String) msgMap.get("25");
			if (ref25 == null) {
				log.error("25域为空");
				return "";
			}
			bw.write(":25:");
			bw.write(ref25);
			bw.newLine();

			
			String ref28C = (String) msgMap.get("28C");
			if (ref28C == null) {
				log.error("28C域为空");
				return "";
			}
			bw.write(":28C:");
			bw.write(ref28C);
			bw.newLine();

			String ref60F = (String) msgMap.get("60F");
			String ref60M = (String) msgMap.get("60M");
			if (isNotEmpty(ref60F)) {
				bw.write(":60F:");
				bw.write(AbstractMTPackMessage.exchangeMoney(ref60F));
				bw.newLine();
			} else if (isNotEmpty(ref60M)) {
				bw.write(":60M:");
				bw.write(AbstractMTPackMessage.exchangeMoney(ref60M));
				bw.newLine();
			} else {
				log.error("60a域为空");
				return "";
			}

			@SuppressWarnings("unchecked")
			List<Map<String, Object>> ref61s = (List<Map<String, Object>>) msgMap
					.get("61");
			if (ref61s != null && ref61s.size() > 0) {
				gener950_61(bw, ref61s);
			}

			String ref62F = (String) msgMap.get("62F");
			if (ref62F == null) {
				log.error("62F域为空");
				return "";
			}
			bw.write(":62F:");
			bw.write(AbstractMTPackMessage.exchangeMoney(ref62F));
			bw.newLine();
			
			String ref64 = (String) msgMap.get("64");
			if (isNotEmpty(ref64)) {
				bw.write(":64:");
				bw.write(AbstractMTPackMessage.exchangeMoney(ref64));
				bw.newLine();
			}

			bw.write("-}");
			bw.flush();
			return sw.toString();
		} catch (Exception e) {
			log.error("gener950 error:", e);
			return "";
		} finally {
			IOUtils.closeQuietly(bw);
		}
	}

	private static void gener950_61(SwtBufferedWriter bw,
			List<Map<String, Object>> ref61s) throws IOException {
		for (Map<String, Object> ref61 : ref61s) {
			bw.write(":61:");
			bw.write(gener950_61ele(ref61));
			bw.newLine();
		}
	}

	private static String gener950_61ele(Map<String, Object> ref61){
		StringBuilder sb = new StringBuilder();
		String ref61_1 = (String) ref61.get("ref61_1");
		String ref61_2 = (String) ref61.get("ref61_2");
		String ref61_3 = (String) ref61.get("ref61_3");
		String ref61_4 = (String) ref61.get("ref61_4");
		String ref61_5 = AbstractMTPackMessage.exchangeMoney(ref61.get("ref61_5").toString());
		String ref61_6 = (String) ref61.get("ref61_6");
		String ref61_7 = (String) ref61.get("ref61_7");
		String ref61_8 = (String) ref61.get("ref61_8");
		String ref61_9 = (String) ref61.get("ref61_9");
		if (isNotEmpty(ref61_1)) {
			sb.append(ref61_1);
		}
		if (isNotEmpty(ref61_2)) {
			sb.append(ref61_2);
		}
		if (isNotEmpty(ref61_3)) {
			sb.append(ref61_3);
		}
		if (isNotEmpty(ref61_4)) {
			sb.append(ref61_4);
		}
		if (isNotEmpty(ref61_5)) {
			sb.append(ref61_5);
		}
		if (isNotEmpty(ref61_6)) {
			sb.append(ref61_6);
		}
		if (isNotEmpty(ref61_7)) {
			sb.append(ref61_7);
		}
		if (isNotEmpty(ref61_8)) {
			sb.append(AbstractMTPackMessage.ESCAPE+ref61_8);
		}
		if (isNotEmpty(ref61_9)) {
			sb.append(SwtBufferedWriter.NEW_LINE);
			sb.append(ref61_9);
		}
		return sb.toString();
	}
	
	public static List<String> gener950Zd(List<Map<String, Object>> ref61s) throws IOException {
		List<String> rs=new LinkedList<String>();
		for (Map<String, Object> ref61 : ref61s) {
			rs.add(gener950_61ele(ref61));
		}
		return rs;
	}
			
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
	}

}
