package com.brilliance.trnchk.ext;

import java.security.InvalidKeyException;
import java.security.KeyFactory;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Signature;
import java.security.SignatureException;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

import org.apache.commons.codec.binary.Base64;

import com.sun.org.apache.xml.internal.security.exceptions.Base64DecodingException;

public class Sha1WithRsaUtil {

	public static void main(String[] args) {

		try {
			KeyPairGenerator gen = KeyPairGenerator.getInstance("RSA");
			gen.initialize(2048);
			KeyPair pair = gen.generateKeyPair();
			// rsa生成一对公私钥
			PublicKey publicKey = pair.getPublic();
			PrivateKey privateKey = pair.getPrivate();
			System.out.println(new String(Base64.encodeBase64((privateKey.getEncoded()))));
			System.out.println(new String(Base64.encodeBase64((publicKey.getEncoded()))));
			// SHA1withRSA算法进行签名
			Signature sign = Signature.getInstance("SHA1withRSA");
			sign.initSign(privateKey);
			byte[] data = "sss".getBytes();
			// 更新用于签名的数据
			sign.update(data);
			byte[] signature = sign.sign();
			Signature verifySign = Signature.getInstance("SHA1withRSA");
			verifySign.initVerify(publicKey);
			// 用于验签的数据
			verifySign.update(data);
			boolean flag = verifySign.verify(signature);
			System.out.println(flag);

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public static byte[] signWhole(String privateKey, String param) {
		// 使用私钥加签
		byte[] signature = null;
		try {
			// 获取privatekey
			byte[] keyByte = com.sun.org.apache.xml.internal.security.utils.Base64.decode(privateKey);
			KeyFactory keyfactory = KeyFactory.getInstance("RSA");
			PKCS8EncodedKeySpec encoderule = new PKCS8EncodedKeySpec(keyByte);
			PrivateKey privatekey = keyfactory.generatePrivate(encoderule);

			// 用私钥给入参加签
			Signature sign = Signature.getInstance("SHA1WithRSA");
			sign.initSign(privatekey);
			sign.update(param.getBytes());

			signature = sign.sign();

		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (InvalidKeySpecException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SignatureException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvalidKeyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Base64DecodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return signature;
	}

	public static boolean verifyWhole(String param, byte[] signdata, String publickey) {
		try {
			// 获取公钥
			KeyFactory keyFactory = KeyFactory.getInstance("RSA");

			X509EncodedKeySpec encodeRule = new X509EncodedKeySpec(com.sun.org.apache.xml.internal.security.utils.Base64.decode(publickey));
			PublicKey publicKey = keyFactory.generatePublic(encodeRule);

			// 用获取到的公钥对 入参中未加签参数param 与 入参中的加签之后的参数signature 进行验签
			Signature sign = Signature.getInstance("SHA1WithRSA");
			sign.initVerify(publicKey);
			sign.update(param.getBytes());

			// 验证签名
			return sign.verify(signdata);

		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvalidKeySpecException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SignatureException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvalidKeyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Base64DecodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return false;
	}

}
