<#import "/func.ftl" as func>
<#macro ExecutableUnit pars type encode>
<#if pars.label=="field" && (!(pars.etag??) || pars.etag=="")>
<@func.handleVal par=pars encode=encode/>
<#elseif pars.label=="field" && type="in" && pars.etag?? && pars.etag!="">
<@ParseField fieldpar=pars encode=encode/>
<#elseif pars.label=="field" && type="out" && pars.etag?? && pars.etag!="">
<@PackField fieldpar=pars encode=encode/>
<#elseif pars.label=="log">
<@func.log par=pars/>
<#elseif pars.label=="if">
<@func.handleif par=pars encode=encode type=type/>
<#elseif pars.label=="foreach">
<@func.handleforeach par=pars encode=encode type=type/>
<#elseif pars.label=="while">
<@func.handlewhile par=pars encode=encode type=type/>
<#elseif pars.label=="continue" || pars.label=="break">
${pars.label};
<#elseif pars.label=="call">
<@func.handlecall par=pars encode=encode type=type/>
<#elseif pars.label=="validator">
<@func.handlevalidator par=pars encode=encode type=type/>
</#if>
</#macro>

<#-- 解析时使用的field -->
<#macro ParseField fieldpar encode>
<#if currentFilter?? && currentFilter=="XmlFilter">
	<#assign xmlparsefieldtype=methodkit("ternaryCalculation", fieldpar.type!, "string")/>
	<#assign curtag=methodkit("declareVariables", fieldpar.tag!, xmlparsefieldtype, fieldpar.value!, currentFilter, transactionName)/>
	${curtag} = ${methodkit("forceConversion", fieldpar.tag!, "object", transactionName)}ExecutableUnit.parseXmlNode(ctx, doc, <@func.toString tmp=fieldpar.etag/>, <@func.toString tmp=xmlparsefieldtype/>);
<#elseif currentFilter?? && currentFilter=="SqlFilter">
	<#assign sqlparseetag = methodkit("handleExpression", "", "string", fieldpar.etag!, currentFilter, transactionName)>
	<#if sqlparseetag[1..6]=="commit">
		ExecutableUnit.dbConnectionCommit(ctx);
	<#elseif sqlparseetag[1..5]=="close">
		ExecutableUnit.dbConnectionClose(ctx);
	<#elseif sqlparseetag[1..5]=="begin">
		ExecutableUnit.closeAutoCommit(ctx);
	<#elseif sqlparseetag[1..15]=="autocommit-true">
		ExecutableUnit.openAutoCommit(ctx);
	<#elseif sqlparseetag[1..9]=="allcommit">
		ExecutableUnit.dbConnectionAllCommit(ctx);
	<#elseif (sqlparseetag?upper_case)[1..4]=="CALL" || sqlparseetag[1]=="{">
		<#-- 执行存储过程 -->
		<#if (fieldpar.type!lower_case)=="resultset">
			<#assign curtag=methodkit("declareVariables", fieldpar.tag!, "java.sql.ResultSet", fieldpar.value!, currentFilter, transactionName)/>
			<#assign proceduretype=r"(ResultSet)"/>
		<#else>
			<#assign curtag=methodkit("declareVariables", fieldpar.tag!, "map", fieldpar.value!, currentFilter, transactionName)/>
			<#assign proceduretype=r"(Map<String, Object>)"/>
		</#if>
		${curtag} = ${proceduretype}ExecutableUnit.executeProcedure(${sqlparseetag!},<@func.toString tmp=fieldpar.type!/>,new Object[][]{
			<#list fieldpar.arguments as argument>
				<#assign procedureisnotlast=argument_index != (fieldpar.arguments?size-1)/>
				<#assign argumentdirection=(argument.direction!)?trim?upper_case/>
				<#assign argumenttype=(argument.type!)?upper_case/>
				{
					<#-- 参数一 -->
					<#if argumentdirection=="OUT" || argumentdirection=="INOUT">
						<#if argumenttype=="CURSOR">
							oracle.jdbc.OracleTypes.CURSOR,
						<#else>
							new SqlFilter().getReflectField(Types.class, ${argumenttype}),
						</#if>
					<#else>
						null,
					</#if>
					<#-- 参数二 -->
					${argumentdirection},
					<#-- 参数三 -->
					<#if argumentdirection=="IN" || argumentdirection=="INOUT">
						<#if argument.type?? && argument.type!="">
							(${methodkit("formatType",argument.type!)})(${methodkit("handleExpression", "", argument.type!, argument.value!, currentFilter, transactionName)}),
						<#else>
							${methodkit("handleExpression", "", argument.type!, argument.value!, currentFilter, transactionName)},
						</#if>
					<#else>
						null,
					</#if>
					<#-- 参数四 -->
					${argument.id!}
				}<#if procedureisnotlast>,</#if>
			</#list>
		},ctx);
	<#else>
		<#if (sqlparseetag?upper_case)[1..6]=="SELECT">
			<#if (fieldpar.type!upper_case)=="LST">
				<#assign curtag=methodkit("declareVariables", fieldpar.tag!, "arraylist", fieldpar.value!, currentFilter, transactionName)/>
				<#assign proceduretype=r"(List<Map<String, Object>>)"/>
			<#else>
				<#assign curtag=methodkit("declareVariables", fieldpar.tag!, "java.sql.ResultSet", fieldpar.value!, currentFilter, transactionName)/>
				<#assign proceduretype=r"(ResultSet)"/>
			</#if>
		<#else>
			<#assign curtag=methodkit("declareVariables", fieldpar.tag!, "object", fieldpar.value!, currentFilter, transactionName)/>
			<#assign proceduretype=""/>
		</#if>
		${curtag} = ${proceduretype}ExecutableUnit.executeSql(${sqlparseetag!},<@func.toString tmp=fieldpar.type!/>,new Object[]{
			<#list fieldpar.arguments as argument>
				<#assign procedureisnotlast=argument_index != (fieldpar.arguments?size-1)/>
				<#if argument.type?? && argument.type!="">
					(${methodkit("formatType",argument.type!)})(${methodkit("handleExpression", "", argument.type!, argument.value!, currentFilter, transactionName)})<#if procedureisnotlast>,</#if>
				<#else>
					${methodkit("handleExpression", "", argument.type!, argument.value!, currentFilter, transactionName)}<#if procedureisnotlast>,</#if>
				</#if>
			</#list>
		},new String[]{
			<#list fieldpar.arguments as argument>
				<#assign procedureisnotlast=argument_index != (fieldpar.arguments?size-1)/>
				<#if argument.id?? && argument.id!="">
					${argument.id!}<#if procedureisnotlast>,</#if>
				<#else>
					""<#if procedureisnotlast>,</#if>
				</#if>
			</#list>
		},ctx);
	</#if>
</#if>
	<@func.handleVal par=fieldpar encode=encode/>
</#macro>

<#-- 组装时使用的field -->
<#macro PackField fieldpar encode>
<#if currentFilter?? && currentFilter=="XmlFilter">
	<#assign tcurtag=methodkit("declareVariables", fieldpar.tag!, fieldpar.type!, fieldpar.value!, currentFilter, transactionName)/>
	<#assign curtag=methodkit("declareVariables", fieldpar.tag!, fieldpar.type!, fieldpar.value!, currentFilter, transactionName)/>
	${tcurtag} = ${methodkit("handleExpression", fieldpar.tag!, fieldpar.type!, fieldpar.value!, currentFilter, transactionName)};
	<#if fieldpar.fill?? && fieldpar.fill != "" && fieldpar.size?? && fieldpar.size != "">
		<#assign XmlFilterTag=methodkit("declareVariables", "fillArgs", "string[]", "", currentFilter, transactionName)/>
		${XmlFilterTag} = <@func.toString tmp=fieldpar.fill/>.split(",");
        ${curtag} = ${methodkit("forceConversion", fieldpar.tag!, "string", transactionName)}ExecutableUnit.fillWithChar(${curtag}.toString(), fillArgs[1], fillArgs[0], ${fieldpar.size}, ${methodkit("handleExpression", fieldpar.tag!, fieldpar.type!, encode!, currentFilter, transactionName)});
	</#if>
		doc = ExecutableUnit.packXmlNode(ctx, doc, <@func.toString tmp=fieldpar.etag/>, ${curtag}, ${methodkit("handleExpression", fieldpar.tag!, fieldpar.type!, encode!, currentFilter, transactionName)});
<#elseif currentFilter?? && currentFilter=="SqlFilter">
	<#assign sqlpacketag = methodkit("handleExpression", "", "string", fieldpar.etag!, currentFilter, transactionName)>
	<#if sqlpacketag[1..6]=="commit">
		ExecutableUnit.dbConnectionCommit(ctx);
	<#elseif sqlpacketag[1..5]=="begin">
		ExecutableUnit.jotmHelperBegin(ctx);
	<#elseif sqlpacketag[1..9]=="allcommit">
		ExecutableUnit.dbConnectionAllCommit(ctx);
	<#else>
		<#if (sqlpacketag?upper_case)[1..6]=="SELECT">
			<#if (fieldpar.type!upper_case)=="LST">
				<#assign curtag=methodkit("declareVariables", fieldpar.tag!, "arraylist", fieldpar.value!, currentFilter, transactionName)/>
				<#assign proceduretype=r"(List<Map<String, Object>>)"/>
			<#else>
				<#assign curtag=methodkit("declareVariables", fieldpar.tag!, "java.sql.ResultSet", fieldpar.value!, currentFilter, transactionName)/>
				<#assign proceduretype=r"(ResultSet)"/>
			</#if>
		<#else>
			<#assign curtag=methodkit("declareVariables", fieldpar.tag!, "object", fieldpar.value!, currentFilter, transactionName)/>
			<#assign proceduretype=""/>
		</#if>
		${curtag} = ${proceduretype}ExecutableUnit.executeSql(${sqlpacketag!},<@func.toString tmp=fieldpar.type!/>,new Object[]{
			<#list fieldpar.arguments as argument>
				<#assign procedureisnotlast=argument_index != (fieldpar.arguments?size-1)/>
				<#if argument.type?? && argument.type!="">
					(${methodkit("formatType",argument.type!)})(${methodkit("handleExpression", "", argument.type!, argument.value!, currentFilter, transactionName)})<#if procedureisnotlast>,</#if>
				<#else>
					${methodkit("handleExpression", "", argument.type!, argument.value!, currentFilter, transactionName)}<#if procedureisnotlast>,</#if>
				</#if>
			</#list>
		},new String[]{
			<#list fieldpar.arguments as argument>
				<#assign procedureisnotlast=argument_index != (fieldpar.arguments?size-1)/>
				<#if argument.id?? && argument.id!="">
					${argument.id!}<#if procedureisnotlast>,</#if>
				<#else>
					""<#if procedureisnotlast>,</#if>
				</#if>
			</#list>
		},ctx);
	</#if>
</#if>
</#macro>