package ${pkgnam};

<#if web=true>
import javax.ws.rs.POST;
import javax.ws.rs.Path;
</#if>
import com.brilliance.eibs.common.log.*;
import com.brilliance.eibs.core.service.Context;
import com.brilliance.eibs.util.*;
import com.brilliance.ext.code.maker.ExecutableUnit;
import com.brilliance.eibs.core.service.instance.impl.*;
import com.brilliance.eibs.core.exception.*;
import java.util.*;
import java.sql.SQLException;
$$import_packages$$
<#-- 导入组件模板 -->
<#import "/component.ftl" as com>
<#import "/func.ftl" as func>
<#if web=true>
@Path(<@func.toString tmp=interfaceName/>)
</#if>
public class ${interfaceName?cap_first}Imp implements ${interfaceName?cap_first}{
<#-- 每个交易就是一个函数 -->
<#list transactions as trn>
<#global transactionName=trn.transactionName>
<#if web=true>
	@POST
	@Path(<@func.toString tmp=trn.transactionName/>)
	@Override
	public String ${trn.transactionName}(String requstJson){
		Object[] objs = new Object[1];
		objs[0] = requstJson;
<#else>
	public Object ${trn.transactionName}(Object[] objs){
</#if>
		ILog logger = TrnLogFactory.getTrnLog();
		Context ctx = ExecutableUnit.makeContext(<@func.toString tmp=interfaceName/>, <@func.toString tmp=trn.transactionName/>, objs, <@func.toString tmp=trn.LogLevel/>);
		Object object = null;
		Object val = null;
		try{
<#-- 每个组件就是一段执行逻辑 -->
<@func.handleComponent components=trn.components/>
<#if web=true>
			return ctx.getObject().toString();
<#else>
			return ctx.getObject();
</#if>
		}catch (Exception e) {
			SysCode sysCode = ExceptionUtil.getErrorCode(ctx, e);
			String errorMsg = sysCode.getErrorText();
			String errorId = sysCode.getId();
			logger.error(ctx, "[error:" + errorId + "] " + errorMsg);
        }finally {
			try {
				ctx.closeAllConnection();
				ctx.closeJotm();
				ctx.closeJedis();
				ctx.closeTibco();
			} catch (SQLException e) {
				logger.error(ctx,"sql connection close error.", e);
			} catch (Exception e) {
				logger.error(ctx,"Close connection error", e);
			}
		}
		return null;
	}
</#list>
}