package com.brilliance.eibs.coder;

import org.bouncycastle.jce.provider.BouncyCastleProvider;

import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.Security;

public class Coder {
	static {
		// 加载BouncyCastle组件支持
		Security.addProvider(new BouncyCastleProvider());
	}

	protected static SecureRandom getSecureRandom(String strKey) throws NoSuchAlgorithmException {
		if (strKey == null)
			return null;
		SecureRandom secureRandom = SecureRandom.getInstance("SHA1PRNG");
		secureRandom.setSeed(strKey.getBytes());
		return secureRandom;
	}

}
