package com.brilliance.eibs.coder;

import javax.crypto.*;
import javax.crypto.spec.SecretKeySpec;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

/**
 * @author hujun
 * 对称加密
 *
 */
public class SymmetryCoder
    extends Coder
{

  protected static Key toKey(byte[] key, String algorithm)
      throws InvalidKeyException, NoSuchAlgorithmException, InvalidKeySpecException
  {
    return new SecretKeySpec(key, algorithm);
  }

  protected static byte[] decrypt(byte[] data, byte[] key, String algorithm)
      throws InvalidKeyException, NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, IllegalBlockSizeException,
      BadPaddingException
  {
    Key k = toKey(key, algorithm);
    Cipher cipher = Cipher.getInstance(algorithm);
    cipher.init(Cipher.DECRYPT_MODE, k);
    return cipher.doFinal(data);
  }

  protected static byte[] encrypt(byte[] data, byte[] key, String algorithm)
      throws InvalidKeyException, NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, IllegalBlockSizeException,
      BadPaddingException
  {
    Key k = toKey(key, algorithm);
    Cipher cipher = Cipher.getInstance(k.getAlgorithm());
    cipher.init(Cipher.ENCRYPT_MODE, k);
    return cipher.doFinal(data);
  }

  protected static byte[] generateKey(String strKey, int keySize, String algorithm)
      throws NoSuchAlgorithmException
  {
    KeyGenerator kg = KeyGenerator.getInstance(algorithm);
    kg.init(keySize, getSecureRandom(strKey));
    SecretKey secretKey = kg.generateKey();
    return secretKey.getEncoded();
  }
}
