package com.brilliance.eibs.coder.impl;

import com.brilliance.eibs.coder.SymmetryCoder;

import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.spec.InvalidKeySpecException;

/**
 * @author hujun
 *
 */
public class AESCoder
    extends SymmetryCoder
{

  public static final String KEY_ALGORITHM = "AES";
  public static final int    KEY_SIZE_128  = 128;
  //生成长度超128bits的密钥需
  //单独从Oracle官网下载对应JDK版本的Java Cryptography Extension (JCE) Unlimited Strength Jurisdiction Policy Files文件
  public static final int    KEY_SIZE_192  = 192;
  public static final int    KEY_SIZE_256  = 256;

  //public static final String CIPHER_ALGORITHM = "AES/ECB/PKCS5Padding";

  public static byte[] decrypt(byte[] data, byte[] key)
      throws InvalidKeyException, NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, IllegalBlockSizeException,
      BadPaddingException
  {
    return decrypt(data, key, KEY_ALGORITHM);
  }

  public static byte[] encrypt(byte[] data, byte[] key)
      throws InvalidKeyException, NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, IllegalBlockSizeException,
      BadPaddingException
  {
    return encrypt(data, key, KEY_ALGORITHM);
  }

  public static byte[] initKey(int keySize)
      throws NoSuchAlgorithmException, NoSuchProviderException
  {
    return generateKey(null, keySize);
  }

  public static byte[] initKey()
      throws NoSuchAlgorithmException, NoSuchProviderException
  {
    return initKey(KEY_SIZE_128);
  }

  public static byte[] generateKey(String strKey, int keySize)
      throws NoSuchAlgorithmException
  {
    return generateKey(strKey, keySize, KEY_ALGORITHM);
  }

  public static byte[] generateKey(String strKey)
      throws NoSuchAlgorithmException
  {
    return generateKey(strKey, KEY_SIZE_128);
  }
}
