package com.brilliance.eibs.coder.impl;

import com.brilliance.eibs.coder.SymmetryCoder;

import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.spec.InvalidKeySpecException;

/**
 * @author hujun
 *
 */
public class DESCoder
    extends SymmetryCoder
{

  private static final String KEY_ALGORITHM = "DES";
  public static final int    KEY_SIZE_64   = 64;
  public static final int    KEY_SIZE_56   = 56;

  //public static final String CIPHER_ALGORITHM = "DES/ECB/PKCS5Padding";

  public static byte[] decrypt(byte[] data, byte[] key)
      throws InvalidKeyException, NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, IllegalBlockSizeException,
      BadPaddingException
  {
    return decrypt(data, key, KEY_ALGORITHM);
  }

  public static byte[] encrypt(byte[] data, byte[] key)
      throws InvalidKeyException, NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, IllegalBlockSizeException,
      BadPaddingException
  {
    return encrypt(data, key, KEY_ALGORITHM);
  }

  public static byte[] initKey(int keySize)
      throws NoSuchAlgorithmException, NoSuchProviderException
  {
    return generateKey(null, keySize);
  }

  public static byte[] initKey()
      throws NoSuchAlgorithmException, NoSuchProviderException
  {
    return initKey(KEY_SIZE_56);
  }

  public static byte[] generateKey(String strKey, int keySize)
      throws NoSuchAlgorithmException
  {
    return generateKey(strKey, keySize, KEY_ALGORITHM);
  }

  public static byte[] generateKey(String strKey)
      throws NoSuchAlgorithmException
  {
    return generateKey(strKey, KEY_SIZE_56);
  }
}
