package com.brilliance.eibs.coder.impl;

import com.brilliance.eibs.coder.Coder;
import org.apache.commons.codec.digest.DigestUtils;
import org.bouncycastle.util.encoders.Hex;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * @author hujun
 *
 */
public class SHACoder extends Coder
{

  public static byte[] encodeSHA(String data)
  {
    return DigestUtils.sha(data);
  }

  public static String encodeSHAHex(String data)
  {
    return DigestUtils.shaHex(data);
  }

  public static byte[] encodeSHA256(String data)
  {
    return DigestUtils.sha256(data);
  }

  public static String encodeSHA256Hex(String data)
  {
    return DigestUtils.sha256Hex(data);
  }

  public static byte[] encodeSHA384(String data)
  {
    return DigestUtils.sha384(data);
  }

  public static String encodeSHA384Hex(String data)
  {
    return DigestUtils.sha384Hex(data);
  }

  public static byte[] encodeSHA512(String data)
  {
    return DigestUtils.sha512(data);
  }

  public static String encodeSHA512Hex(String data)
  {
    return DigestUtils.sha512Hex(data);
  }

  public static byte[] encodeSHA224(byte[] data)
      throws NoSuchAlgorithmException
  {
    MessageDigest md = MessageDigest.getInstance("SHA-224");
    return md.digest(data);
  }

  public static String encodeSHA224Hex(byte[] data)
      throws NoSuchAlgorithmException
  {
    byte[] b = encodeSHA224(data);
    return new String(Hex.encode(b));
  }
}
