package com.brilliance.eibs.core.exception;

import com.brilliance.eibs.core.model.IDefinition;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

/**
 * 系统错误码类
 */
public class SysCode
    implements IDefinition
{
  private static final long serialVersionUID = 1L;

  private String            id;                   // 系统错误码ID
  private String            ref;
  private String            errorText;            // 错误消息文本

  public String getRef()
  {
    return ref;
  }

  public void setRef(String ref)
  {
    this.ref = ref;
  }

  public String getId()
  {
    return id;
  }

  public void setId(String id)
  {
    this.id = id;
  }

  public String getErrorText()
  {
    return errorText;
  }

  public void setErrorText(String errorText)
  {
    this.errorText = errorText;
  }

  @Override
  public SysCode clone()
      throws CloneNotSupportedException
  {
    SysCode sysCode = new SysCode();
    sysCode.setErrorText(getErrorText());
    sysCode.setId(getId());
    return sysCode;
  }

  public boolean equals(Object obj)
  {
    return EqualsBuilder.reflectionEquals(this, obj);
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

}
