package com.brilliance.eibs.core.model;

import com.brilliance.eibs.core.model.impl.ConnectionDef;

import java.util.List;
import java.util.Map;

/**
 * 数据连接定义接口类
 * @author xiaoyuanzhen
 */
public interface IConnectionDef
    extends IExecutableDef, IAbsDef
{
  public Map<String, IPropertyDef> getPropertyMap();

  public IPropertyDef getProperty(String key);

  public void addProperty(String key, IPropertyDef propertyDef);
  
  public void addProperty(String key,String value);
  
  public void addProperty(IPropertyDef propertyDef);

  public void addSub(Object obj);

  public void setType(String type);

  public String getType();

  public void setEncoding(String encoding);

  public String getEncoding();

  public String getJoinedid();

  public void setJoinedid(String joinedid);

  /**
   * 获取连接池设置
   * @return
   */
  public ConnectionDef.PoolSetting getPoolSetting();

  /**
   * 设置连接池设置
   * @param poolSetting
   */
  public void setPoolSetting(ConnectionDef.PoolSetting poolSetting);

  /**
   * 是否支持连接池
   * @return
   */
  public boolean isPooled();

  /**
   * 设置支持连接池
   * @param pooled
   */
  public void setPooled(boolean pooled);

  public boolean getKeepalive();

  public void setKeepalive(boolean keepalive);

  public List<Object> getSubList();

  public void setSubList(List<Object> subList);

  public void combine(IConnectionDef connectionDef);

  public void addEncryptProperty(String key, String xkey);

  public Map<String, String> getEncryptPropMap();
}
