package com.brilliance.eibs.core.model.converter;

import com.brilliance.eibs.core.model.IPropertyDef;
import com.brilliance.eibs.core.model.impl.ConnectionDef;
import com.brilliance.eibs.util.StringUtil;
import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.ExtendedHierarchicalStreamWriterHelper;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

public class ConnectionDefConverter
    implements Converter
{

 

  @SuppressWarnings("rawtypes")
  @Override
  public boolean canConvert(Class clazz)
  {
    // TODO Auto-generated method stub
    return clazz.equals(ConnectionDef.class);
  }

  @SuppressWarnings("rawtypes")
  @Override
  public void marshal(Object source, HierarchicalStreamWriter writer, MarshallingContext context)
  {
    ConnectionDef somap = (ConnectionDef) source;
    if (somap != null)
    {
      if(!StringUtil.isEmpty(somap.getRef()))
        writer.addAttribute("ref", somap.getRef());
      if(!StringUtil.isEmpty(somap.getType()))
        writer.addAttribute("type", somap.getType());
      if(!StringUtil.isEmpty(somap.getEncoding()))
        writer.addAttribute("encoding", somap.getEncoding());
      if(!StringUtil.isEmpty(somap.getJoinedid()))
        writer.addAttribute("joinedid", somap.getJoinedid());
      if(!StringUtil.isEmpty(somap.getTimes()))
        writer.addAttribute("times", somap.getTimes());
      Map map = somap.getPropertyMap();
      if (map != null)
        for (Iterator iterator = map.entrySet().iterator(); iterator.hasNext();)
        {
          Entry entry = (Entry) iterator.next();
          ExtendedHierarchicalStreamWriterHelper.startNode(writer, "property", Entry.class);
          writer.addAttribute("name", entry.getKey().toString());
          Object obj = entry.getValue();
          if (obj instanceof IPropertyDef)
          {
            obj = ((IPropertyDef) obj);
            writer.addAttribute("value", ((IPropertyDef) obj).getValue());
          }

          writer.endNode();
        }
    }

   
  }

  @Override
  public Object unmarshal(HierarchicalStreamReader arg0, UnmarshallingContext arg1)
  {
    // TODO Auto-generated method stub
    return null;
  }

}
