package com.brilliance.eibs.core.model.converter;

import com.brilliance.eibs.core.model.impl.ServiceDef;
import com.brilliance.eibs.util.StringUtil;
import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.ExtendedHierarchicalStreamWriterHelper;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

public class ServiceDefConverter
    implements Converter
{

 

  @SuppressWarnings("rawtypes")
  @Override
  public boolean canConvert(Class clazz)
  {
    // TODO Auto-generated method stub
    return clazz.equals(ServiceDef.class);
  }

  @SuppressWarnings("rawtypes")
  @Override
  public void marshal(Object source, HierarchicalStreamWriter writer, MarshallingContext context)
  {
    ServiceDef somap = (ServiceDef) source;
    if (somap != null)
    {
      if(!StringUtil.isEmpty(somap.getId()))
        writer.addAttribute("id", somap.getId());
      if(!StringUtil.isEmpty(somap.getType()))
        writer.addAttribute("type", somap.getType());
      if(!StringUtil.isEmpty(somap.getEncoding()))
        writer.addAttribute("encoding", somap.getEncoding());
      if(!StringUtil.isEmpty(somap.getState()))
        writer.addAttribute("state", somap.getState());
      if(!StringUtil.isEmpty(somap.getLanguage()))
        writer.addAttribute("language", somap.getLanguage());
      if(!StringUtil.isEmpty(somap.getExpression()))
        writer.addAttribute("expression", somap.getExpression());
      if(!StringUtil.isEmpty(somap.getDescription()))
        writer.addAttribute("description", somap.getDescription());
      Map map = somap.getPropertyMap();
      if (map != null)
        for (Iterator iterator = map.entrySet().iterator(); iterator.hasNext();)
        {
          Entry entry = (Entry) iterator.next();
          ExtendedHierarchicalStreamWriterHelper.startNode(writer, "property", Entry.class);
          writer.addAttribute("name", entry.getKey().toString());
          writer.addAttribute("value", entry.getValue().toString());

          writer.endNode();
        }
    }

   
  }

  @Override
  public Object unmarshal(HierarchicalStreamReader arg0, UnmarshallingContext arg1)
  {
    // TODO Auto-generated method stub
    return null;
  }

}
