package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IAbsDef;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.util.ArrayList;
import java.util.List;

public abstract class AbsDef implements IAbsDef {
    protected transient IAbsDef parentDef;
    protected String label;

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public void setParentDef(IAbsDef parentDef) {
        this.parentDef = parentDef;
    }

    public IAbsDef getParentDef() {
        return parentDef;
    }

    public boolean equals(Object obj) {
        boolean b = EqualsBuilder.reflectionEquals(this, obj);
        return b;
    }

    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String toString() {
        StringBuffer buffer = new StringBuffer();
        buffer.append("[" + getUnique() + "]");
        if (parentDef != null) {
            buffer.insert(0, parentDef + "-");
        }
        return buffer.toString();
    }

    @Override
    public boolean subNodeOf(Class<? extends IAbsDef> type) {
        IAbsDef parentDef = this.parentDef;
        while (parentDef != null) {
            if (parentDef.getClass().equals(type)) return true;
            parentDef = parentDef.getParentDef();
        }
        return false;
    }


    public List<IAbsDef> getExecuteList() {
        return new ArrayList<IAbsDef>();

    }

}
