package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IArgumentDef;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;

@XStreamAlias("argument")
public class ArgumentDef
    extends AbsDef
    implements IArgumentDef, Serializable
{
  private static final long serialVersionUID = 1L;
  @XStreamAsAttribute
  private String            id;
  @XStreamAsAttribute
  private String            type;
  @XStreamAsAttribute
  private String            value;
  @XStreamAsAttribute
  private String            description;
  @XStreamAsAttribute
  private String            direction;

  public String getId()
  {
    return id;
  }

  public void setId(String id)
  {
    this.id = id;
  }

  public String getType()
  {
    return type;
  }

  public void setType(String type)
  {
    this.type = type;
  }

  public String getValue()
  {
    return value;
  }

  public void setValue(String value)
  {
    this.value = value;
  }

  public String getDirection()
  {
    return direction;
  }

  public void setDirection(String direction)
  {
    this.direction = direction;
  }

  public String getDescription()
  {
    return description;
  }

  public void setDescription(String description)
  {
    this.description = description;
  }

  public boolean equals(Object obj)
  {
    boolean b = EqualsBuilder.reflectionEquals(this, obj);
    return b;
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @Override
  public String getUnique()
  {
    return "argument:" + id;
  }

}
