package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.frame.AbsDefFactory;
import com.brilliance.eibs.core.frame.IFactoryDef;
import com.brilliance.eibs.core.model.IArgumentDef;
import com.brilliance.eibs.core.model.ICallDef;
import com.brilliance.eibs.core.model.converter.NullStringConverter;
import com.thoughtworks.xstream.annotations.*;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.util.ArrayList;
import java.util.List;

@XStreamAlias("call")
@XStreamConverter(NullStringConverter.class)
public class CallDef extends AbsDef implements ICallDef, IFactoryDef {
    @XStreamAsAttribute
    private String tag;
    @XStreamAsAttribute
    private String scope;
    @XStreamAsAttribute
    private String interfaceName;
    @XStreamAsAttribute
    private String transactionName;
    @XStreamAsAttribute
    private String type;
    @XStreamAsAttribute
    private String mode;// 同步还是异步 T/S
    @XStreamAsAttribute
    private String pre;
    @XStreamAsAttribute
    private String merge;
    @XStreamImplicit
    private List<IArgumentDef> arguments = new ArrayList<IArgumentDef>();

    @XStreamOmitField
    private String xpath;

    public String getTag() {
        return tag;
    }

    public void setTag(String tag) {
        this.tag = tag;
    }

    public String getScope() {
        return scope;
    }

    public void setScope(String scope) {
        this.scope = scope;
    }

    public String getInterfaceName() {
        return interfaceName;
    }

    public void setInterfaceName(String interfaceName) {
        this.interfaceName = interfaceName;
    }

    public String getTransactionName() {
        return transactionName;
    }

    public void setTransactionName(String transactionName) {
        this.transactionName = transactionName;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public List<IArgumentDef> getArguments() {
        return arguments;
    }

    public void setArguments(List<IArgumentDef> arguments) {
        this.arguments = arguments;
    }

    @Override
    public String getUnique() {
        return interfaceName + "/" + transactionName;
    }

    @Override
    public boolean equals(Object obj) {
        return EqualsBuilder.reflectionEquals(this, obj);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    public String getMode() {
        return mode;
    }

    public void setMode(String mode) {
        this.mode = mode;
    }

    public String getXpath() {
        return xpath;
    }

    public void setXpath(String xpath) {
        this.xpath = xpath;
    }

    public String getPre() {
        return pre;
    }

    public void setPre(String pre) {
        this.pre = pre;
    }

    public String getMerge() {
        return merge;
    }

    public void setMerge(String merge) {
        this.merge = merge;
    }

    @Override
    public void load2DefFactory(String locator, String interfaceName) {
        AbsDefFactory.addDef(locator, interfaceName, this);
    }
}
