package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IArgumentDef;
import com.brilliance.eibs.core.model.IConvertorDef;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamImplicit;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@XStreamAlias("convertor")
public class ConvertorDef
    extends AbsDef
    implements Serializable, IConvertorDef
{
  private static final long  serialVersionUID = 1L;
  @XStreamAsAttribute
  private String             tag;
  @XStreamAsAttribute
  private String             scope;
  @XStreamAsAttribute
  private String             value;
  @XStreamAsAttribute
  private String             errorCode;
  @XStreamAsAttribute
  private String             description;
  @XStreamImplicit
  private List<IArgumentDef> arguments        = new ArrayList<IArgumentDef>(); //参数列表
  

  public String getTag()
  {
    return tag;
  }

  public void setTag(String tag)
  {
    this.tag = tag;
  }

  public String getScope()
  {
    return scope;
  }

  public void setScope(String scope)
  {
    this.scope = scope;
  }

  public String getValue()
  {
    return value;
  }

  public void setValue(String value)
  {
    this.value = value;
  }

  public String getErrorCode()
  {
    return errorCode;
  }

  public void setErrorCode(String errorCode)
  {
    this.errorCode = errorCode;
  }

  public String getDescription()
  {
    return description;
  }

  public void setDescription(String description)
  {
    this.description = description;
  }

  public void addArgument(IArgumentDef argumentDef)
  {
    arguments.add(argumentDef);
  }

  public void setArguments(List<IArgumentDef> arguments)
  {
    this.arguments = arguments;
  }

  public List<IArgumentDef> getArguments()
  {
    return this.arguments;
  }

  public boolean equals(Object obj)
  {
    boolean b = EqualsBuilder.reflectionEquals(this, obj);
    return b;
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @Override
  public String getUnique()
  {
    return "convertor:" + tag;
  }

  

}
