package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.core.model.IFuncDef;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;

public class FuncDef
    extends AbsDef
    implements IFuncDef, Serializable
{
  private static final long serialVersionUID = 1L;

  private String            tag;

  private String            cls;       //类名
  private String            namespace;  //命名空间
  private String            name;
  private String            stc;                   //是否为静态和非静态

  public FuncDef()
  {}

  public String getTag()
  {
    return tag;
  }

  public void setTag(String tag)
  {
    this.tag = tag;
  }

  public String getName()
  {
    return name;
  }

  public void setName(String name)
  {
    this.name = name;
  }

  public String getCls()
  {
    return cls;
  }

  public void setCls(String cls)
  {
    this.cls = cls;
  }

  public String getNamespace()
  {
    return namespace;
  }

  public void setNamespace(String namespace)
  {
    this.namespace = namespace;
  }

  @Override
  public boolean equals(Object obj)
  {
    return EqualsBuilder.reflectionEquals(this, obj);
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @Override
  public void setParentDef(IAbsDef parentDef)
  {
    this.parentDef = parentDef;
  }

  @Override
  public IAbsDef getParentDef()
  {
    return parentDef;
  }

  @Override
  public String getUnique()
  {
    return "function:" + name;
  }

  public String getStc()
  {
    return stc;
  }

  public void setStc(String stc)
  {
    this.stc = stc;
  }

}
