package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.core.model.IArgumentDef;
import com.brilliance.eibs.core.model.IFunctionDef;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class FunctionDef extends AbsDef implements IFunctionDef, Serializable {
	private static final long serialVersionUID = 1L;

	private String tag;
	private String name;
	private String returnType;
	private String scope;
	private String error;
	private final String method = CUSTOM_TYPE;
	private List<Input> inputs = new ArrayList<Input>();
	private List<IArgumentDef> argumentDefs = new ArrayList<IArgumentDef>();
	private List<IAbsDef> executeList = new ArrayList<IAbsDef>();

	public FunctionDef() {
	}

	public FunctionDef(String name, String error) {
		this.name = name;
		this.error = error;
	}

	public String getError() {
		return error;
	}

	public String getMethod() {
		return method;
	}

	public void setError(String error) {
		this.error = error;
	}

	public String getScope() {
		return scope;
	}

	public void setScope(String scope) {
		this.scope = scope;
	}

	public List<IArgumentDef> getArgumentDefs() {
		return argumentDefs;
	}

	public void setArgumentDefs(List<IArgumentDef> argumentDefs) {
		this.argumentDefs = argumentDefs;
	}

	public String getReturnType() {
		return returnType;
	}

	public void setReturnType(String returnType) {
		this.returnType = returnType;
	}

	public String getTag() {
		return tag;
	}

	public void setTag(String tag) {
		this.tag = tag;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public List<Input> getInputs() {
		return inputs;
	}

	public void addInput(Input input) {
		inputs.add(input);
	}

	public List<IAbsDef> getExecuteList() {
		return executeList;
	}

	public void setExecuteList(List<IAbsDef> executeList) {
		this.executeList = executeList;
	}

	public void setInputs(List<Input> inputs) {
		this.inputs = inputs;
	}

	@Override
	public boolean equals(Object obj) {
		return EqualsBuilder.reflectionEquals(this, obj);
	}

	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public void setParentDef(IAbsDef parentDef) {
		this.parentDef = parentDef;
	}

	@Override
	public IAbsDef getParentDef() {
		return parentDef;
	}

	@Override
	public String getUnique() {
		return "function:" + name;
	}

	public class Input implements Serializable {
		private static final long serialVersionUID = 1L;

		private String tag;
		private String type;

		public String getTag() {
			return tag;
		}

		public void setTag(String tag) {
			this.tag = tag;
		}

		public String getType() {
			return type;
		}

		public void setType(String type) {
			this.type = type;
		}

		@Override
		public boolean equals(Object obj) {
			return EqualsBuilder.reflectionEquals(this, obj);
		}

		public int hashCode() {
			return HashCodeBuilder.reflectionHashCode(this);
		}

	}

	public class Output extends Input {
		private static final long serialVersionUID = 1L;

	}

}
