package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IIfDef;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamImplicit;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;

@XStreamAlias("if")
public class IfDef
    extends AbsDef
    implements Serializable, IIfDef
{
  private static final long   serialVersionUID = 1L;
  @XStreamImplicit
  private Map<String, Object> conditionMap     = new LinkedHashMap<String, Object>();
  @XStreamAlias("else")
  private Object              elseCondition;

  public Map<String, Object> getConditionMap()
  {
    return conditionMap;
  }

  public void addConditionMap(String condition, Object value)
  {
    this.conditionMap.put(condition, value);
  }

  public Object getElseCondition()
  {
    return elseCondition;
  }

  public void setElseCondition(Object elseCondition)
  {
    this.elseCondition = elseCondition;
  }

  public boolean equals(Object obj)
  {
    boolean b = EqualsBuilder.reflectionEquals(this, obj);
    return b;
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @Override
  public String getUnique()
  {
    return "if:" + conditionMap.keySet().iterator().next();
  }

}
