package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.ILogDef;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;

@XStreamAlias("log")
public class LogDef extends AbsDef implements ILogDef, Serializable {
	private static final long serialVersionUID = 1L;
	@XStreamAsAttribute
	private String value;
	@XStreamAsAttribute
	private String level;

	public String getLevel() {
		return level;
	}

	public void setLevel(String level) {
		this.level = level;
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public boolean equals(Object obj) {
		return EqualsBuilder.reflectionEquals(this, obj);
	}

	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String getUnique() {
		return "log:" + value;
	}

}
