package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.core.model.IProcessDef;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamImplicit;
import com.thoughtworks.xstream.annotations.XStreamOmitField;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@XStreamAlias("process")
public class ProcessDef
    implements IProcessDef, Serializable
{
  private static final long serialVersionUID = 1L;
  @XStreamOmitField
  private String            id;
  @XStreamOmitField
  private String            exceptionTaskName;
  @XStreamImplicit
  private List<IAbsDef>     subList          = new ArrayList<IAbsDef>();

  public String getId()
  {
    return id;
  }

  public void setId(String id)
  {
    this.id = id;
  }

  public String getExceptionTaskName()
  {
    return exceptionTaskName;
  }

  public void setExceptionTaskName(String exceptionTaskName)
  {
    this.exceptionTaskName = exceptionTaskName;
  }

  public List<IAbsDef> getSubList()
  {
    return subList;
  }

  public void setSubList(List<IAbsDef> subList)
  {
    this.subList = subList;
  }

  public boolean equals(Object obj)
  {
    return EqualsBuilder.reflectionEquals(this, obj);
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @XStreamAlias("step")
  public class TaskDef
      extends AbsDef
      implements Serializable
  {
    private static final long serialVersionUID = 1L;
    @XStreamAsAttribute
    private String            name;
    @XStreamAsAttribute
    private String            value;

    public String getName()
    {
      return name;
    }

    public void setName(String name)
    {
      this.name = name;
    }

    public String getValue()
    {
      return value;
    }

    public void setValue(String value)
    {
      this.value = value;
    }

    public boolean equals(Object obj)
    {
      return EqualsBuilder.reflectionEquals(this, obj);
    }

    public int hashCode()
    {
      return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getUnique()
    {
      return "task";
    }

  }
}
