package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.ISubfieldDef;
import com.brilliance.eibs.core.model.converter.NullStringConverter;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamConverter;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;

@XStreamAlias("subfield")
@XStreamConverter(NullStringConverter.class)
public class SubfieldDef
    extends FieldDef
    implements Serializable, ISubfieldDef
{
  private static final long serialVersionUID = 1L;
  
  @XStreamAsAttribute
  private String            key;
  @XStreamAsAttribute
  private String            srckey;

  public String getKey()
  {
    return key;
  }

  public void setKey(String key)
  {
    this.key = key;
  }

  public static long getSerialversionuid()
  {
    return serialVersionUID;
  }

  public boolean equals(Object obj)
  {
    boolean b = EqualsBuilder.reflectionEquals(this, obj);
    return b;
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  @Override
  public String getUnique()
  {
    return "subfield:" + getEtag();
  }

  public String getSrckey()
  {
    return srckey;
  }

  public void setSrckey(String srckey)
  {
    this.srckey = srckey;
  }

}
