package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IPropertyDef;
import com.brilliance.eibs.core.model.ISwitchDef;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

public class SwitchDef
    implements ISwitchDef, Serializable
{
  private static final long    serialVersionUID = 1L;

  private String               condition;
  private Map<String, CaseDef> caseMap          = new HashMap<String, CaseDef>();

  public String getCondition()
  {
    return condition;
  }

  public void setCondition(String condition)
  {
    this.condition = condition;
  }

  public Map<String, CaseDef> getCaseMap()
  {
    return caseMap;
  }

  public void addCaseMap(String condition, CaseDef value)
  {
    this.caseMap.put(condition, value);
  }

  public boolean equals(Object obj)
  {
    boolean b = EqualsBuilder.reflectionEquals(this, obj);
    return b;
  }

  public int hashCode()
  {
    return HashCodeBuilder.reflectionHashCode(this);
  }

  public class CaseDef
      implements Serializable
  {
    private static final long serialVersionUID = 1L;

    private String            condition;
    private String            value;
    private String            type;

    public String getType()
    {
      return type;
    }

    public void setType(String type)
    {
      this.type = type;
    }

    private IPropertyDef propertyDef;

    public String getCondition()
    {
      return condition;
    }

    public void setCondition(String condition)
    {
      this.condition = condition;
    }

    public String getValue()
    {
      return value;
    }

    public void setValue(String value)
    {
      this.value = value;
    }

    public IPropertyDef getPropertyDef()
    {
      return propertyDef;
    }

    public void setPropertyDef(IPropertyDef propertyDef)
    {
      this.propertyDef = propertyDef;
    }

    public boolean equals(Object obj)
    {
      boolean b = EqualsBuilder.reflectionEquals(this, obj);
      return b;
    }

    public int hashCode()
    {
      return HashCodeBuilder.reflectionHashCode(this);
    }

  }

}
