package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IPropertyDef;
import com.brilliance.eibs.core.model.ITaskDef;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

public class TaskDef implements ITaskDef, Serializable {
	private static final long serialVersionUID = 1L;
	private String id;
	private String state;
	private String description;
	private Map<String, IPropertyDef> propertyMap = new HashMap<String, IPropertyDef>();
	private String otherprocess;
	private String depencency;
	private String date;
	private String continueExcute;

	public String getOtherprocess() {
		return otherprocess;
	}

	public void setOtherprocess(String otherprocess) {
		this.otherprocess = otherprocess;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Map<String, IPropertyDef> getPropertyMap() {
		return propertyMap;
	}

	public void setPropertyMap(Map<String, IPropertyDef> propertyMap) {
		this.propertyMap = propertyMap;
	}

	public void addProperty(String key, IPropertyDef value) {
		this.propertyMap.put(key, value);
	}

	@Override
	public IPropertyDef getProperty(String key) {
		return this.propertyMap.get(key);
	}

	public boolean equals(Object obj) {
		return EqualsBuilder.reflectionEquals(this, obj);
	}

	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	public String getDepencency() {
		return depencency;
	}

	public void setDepencency(String depencency) {
		this.depencency = depencency;
	}

	public String getDate() {
		return date;
	}

	public String getContinueExcute() {
		return continueExcute;
	}

	public void setDate(String date) {
		this.date = date;
	}

	public void setContinueExcute(String continueExcute) {
		this.continueExcute = continueExcute;
	}

}
