package com.brilliance.eibs.core.model.impl;

import com.brilliance.eibs.core.model.IInterfaceDef;
import com.brilliance.eibs.core.model.IProcessDef;
import com.brilliance.eibs.core.model.IStepDef;
import com.brilliance.eibs.core.model.ITransactionDef;
import com.brilliance.eibs.core.model.converter.NullStringConverter;
import com.thoughtworks.xstream.annotations.*;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.util.ArrayList;
import java.util.List;

@XStreamAlias("transaction")
@XStreamConverter(NullStringConverter.class)
public class TransactionDef implements ITransactionDef {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    private transient IInterfaceDef interfaceDef;
    @XStreamAsAttribute
    private String id;
    @XStreamOmitField
    private String description;
    @XStreamOmitField
    private String expression;
    @XStreamAsAttribute
    private String detail;
    @XStreamImplicit
    private List<IStepDef> stepList = new ArrayList<IStepDef>(); // 步骤列表
    @XStreamAlias("process")
    private IProcessDef processDef;
    @XStreamAsAttribute
    private String version;
    @XStreamOmitField
    private String logLevel;
    @XStreamAsAttribute
    private long timeout;
    @XStreamAsAttribute
    private boolean singleton; // 单例模式
    @XStreamAsAttribute
    private boolean reload; // 重连

    public IProcessDef getProcessDef() {
        return processDef;
    }

    public void setProcessDef(IProcessDef processDef) {
        this.processDef = processDef;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getExpression() {
        return expression;
    }

    public void setExpression(String expression) {
        this.expression = expression;
    }

    public IInterfaceDef getInterfaceDef() {
        return interfaceDef;
    }

    public void setInterfaceDef(IInterfaceDef interfaceDef) {
        this.interfaceDef = interfaceDef;
    }

    public List<IStepDef> getSteps() {
        return stepList;
    }

    public void setSteps(List<IStepDef> stepList) {
        this.stepList = stepList;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDetail() {
        return detail;
    }

    public void setDetail(String detail) {
        this.detail = detail;
    }

    public boolean equals(Object obj) {
        return EqualsBuilder.reflectionEquals(this, obj);
    }

    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String getLogLevel() {
        return logLevel;
    }

    public void setLogLevel(String logLevel) {
        this.logLevel = logLevel;
    }

    public boolean isSingleton() {
        return singleton;
    }

    public void setSingleton(boolean singleton) {
        this.singleton = singleton;
    }

    public long getTimeout() {
        return timeout;
    }

    public void setTimeout(long timeout) {
        this.timeout = timeout;
    }

    public boolean isReload() {
        return reload;
    }

    public void setReload(boolean reload) {
        this.reload = reload;
    }

}
