package com.brilliance.eibs.core.model.modelbeans;

import com.brilliance.eibs.core.model.IConnectionDef;
import com.brilliance.eibs.core.model.IInterfaceDef;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * 数据连接定义集合类
 */
public class ConnectionsDef
    implements Serializable
{
  /**
   * 
   */
  private static final long       serialVersionUID = 1L;
  public List<IConnectionDef>     connections      = new ArrayList<IConnectionDef>(); // 数据连接列表
  private transient IInterfaceDef interfaceDefinition;                               // 接口定义

  /**
   * 获取数据连接列表
   * @return
   */
  public List<IConnectionDef> getConnections()
  {
    return connections;
  }

  /**
   * 设置数据连接列表
   * @param connections
   */
  public void setConnections(List<IConnectionDef> connections)
  {
    this.connections = connections;
  }

  /**
   * 获取接口定义
   * @return
   */
  public IInterfaceDef getInterfaceDefinition()
  {
    return interfaceDefinition;
  }

  /**
   * 设置接口定义
   * @param interfaceDefinition
   */
  public void setInterfaceDefinition(IInterfaceDef interfaceDefinition)
  {
    this.interfaceDefinition = interfaceDefinition;
  }

}
