package com.brilliance.eibs.core.service.instance;

import com.brilliance.eibs.core.model.IAbsDef;
import com.brilliance.eibs.core.model.IFunctionDef;
import com.brilliance.eibs.core.model.IReturnDef;
import com.brilliance.eibs.core.model.impl.FunctionDef;
import com.brilliance.eibs.core.service.Context;

/**
 * @author hujun
 *
 *         标准自定义函数流程实例
 */
public class CustomFunctionInstance extends FunctionInstance {

	private Object returnValue;
	private boolean isReturn = false;

	public CustomFunctionInstance(IFunctionDef def, Context context) {
		super(def);
		this.elParser = context.getElParser();
		this.context = new Context();
		// 初始化
		this.context.addVariable("transaction", "____subStepErrorPrinted", false);
		this.context.addVariable("transaction", "____breakDone", true);
		this.context.addVariable("transaction", "____continueDone", true);
		this.context.setElParser(elParser);
		this.context.setCurrentInstance(context.getCurrentInstance());
	}

	@Override
	protected Object handleReturnDef(IReturnDef returnDef) {
		// 处理return节点，用于跳出自定义函数
		isReturn = true;
		return returnValue = super.handleReturnDef(returnDef);
	}

	@Override
	protected Object executeFunctionDef(Object[] params) {
		FunctionDef funcDef = (FunctionDef) def;
		if (params != null)
			for (int i = 0; i < params.length; i++)
				context.addVariable(null, funcDef.getInputs().get(i).getTag(), params[i]);
		for (IAbsDef sub : funcDef.getExecuteList()) {
			handleSubList(sub);
			if (isReturn)
				break;
		}
		return returnValue;
	}

}
