package com.brilliance.eibs.core.service.instance;

import com.brilliance.eibs.core.model.IFunctionDef;
import com.brilliance.eibs.core.model.impl.ReflectDef;

/**
 * @author hujun
 *
 * 反射成员变量流程实例
 */
public class FieldFunctionInstance
    extends FunctionInstance
{

  public FieldFunctionInstance( IFunctionDef def )
  {
    super(def);
  }

  @Override
  protected Object executeFunctionDef(Object[] params)
  {
    ReflectDef reflectDef = (ReflectDef) def;
    if (reflectDef.isStatic())
      return getReflectField(reflectDef.getClazz(), reflectDef.getName());
    return getReflectField(reflectDef.getClazz(), reflectDef.getName(), params[0]);
  }
}
