package com.brilliance.eibs.core.service.instance;

import com.brilliance.eibs.core.exception.InterfaceException;
import com.brilliance.eibs.core.model.IFieldDef;
import com.brilliance.eibs.core.model.IFunctionDef;
import com.brilliance.eibs.core.service.instance.impl.AbsFilter;
import com.brilliance.eibs.el.ApacheEL;
import com.brilliance.eibs.util.StringUtil;

/**
 * @author hujun
 *
 *  自定义函数流程实例
 */
public abstract class FunctionInstance
    extends AbsFilter
    implements IFunctionInstance
{

  protected IFunctionDef def;

  public FunctionInstance( IFunctionDef def )
  {
    this.def = def;
  }

  public FunctionInstance( IFunctionDef def, ApacheEL elParser )
  {
    this.def = def;
  }

  @Override
  public Object execute(Object[] params)
      throws Exception
  {
    try
    {
      return executeFunctionDef(params);
    }
    catch (Exception e)
    {
      if (StringUtil.isEmpty(def.getError()))
        throw e;
      throw new InterfaceException(def.getError());
    }
  }

  protected abstract Object executeFunctionDef(Object[] params);

  @Override
  public Object getFieldValue(IFieldDef fieldDef)
  {
    return null;
  }

}
