package com.brilliance.eibs.core.service.instance;

import com.brilliance.eibs.core.frame.instance.IInstance;
import com.brilliance.eibs.core.model.IExecutableDef;
import com.brilliance.eibs.core.service.Context;
import com.brilliance.eibs.el.AbstractEL;

/**
 * 可执行实例接口，目前的子类包括filter，connection，提供此类实例共同的方法
 * 
 * @author hujun
 *
 */
public interface IExecutableInstance extends IInstance {
	static final String TRUST_IP_SYMBOL = "trust_ip";
	static final String THREAD_POOL_SIZE_SYMBOL = "thread_pool_size";
	static final String REQUEST_QUEUE_LEN_SYMBOL = "request_queue_len";
	static final String PATH_SYMBOL = "path";
	static final String PORT_SYMBOL = "port";
	static final String LINK_SYMBOL = "link";
	static final String IP_SYMBOL = "ip";
	static final String ALIVE_SYMBOL = "alive";
	static final String ALIVE_STRATEGY_SYMBOL = "alive_strategy";
	static final String HEAR_BEAT = "heartbeat";
	static final String URI_SYMBOL = "uri";
	static final String CLASS_SYMBOL = "class";
	static final String METHOD_SYMBOL = "method";
	static final String READ_FLG = "in";
	static final String WRITE_FLG = "out";
	static final String RECORD_SPLIT_SYMBOL = "record_split";
	static final String FIELD_SPLIT_SYMBOL = "field_split";
	static final String CONNECT_TIMEOUT_SYMBOL = "connect_timeout";
	static final String RECEIVE_TIMEOUT_SYMBOL = "receive_timeout";
	static final String SO_TIMEOUT_SYMBOL = "so_timeout";
	static final String DEFAULT_TIMEOUT_SYMBOL = "default_timeout";
	static final String DELAY_TIME = "delay_time";
	static final String AES_KEY_SYMBOL = "aes_key";
	static final String RETURN_TYPE = "return_type";
	static final String MODE = "mode";
	static final String RSA_PRIVIATE_KEY = "rsa_private_key";
	static final String RSA_PUBLIC_KEY = "rsa_public_key";
	static final String FIELD_EXCEPTION_TYPE = "exception";

	static final String TYPE = "type";
	static final String FIELD_TYPE_STRING = "String";
	static final String FIELD_TYPE_INT = "int";
	static final String FIELD_TYPE_DOUBLE = "double";
	static final String FIELD_TYPE_DATE = "date";
	static final String FIELD_TYPE_NUMBER = "number";
	static final String FIELD_TYPE_DECIMAL = "decimal";

	static final String MQ_CHANNEL_SYMBOL = "channel";
	static final String MQ_QUEUE_SYMBOL = "queue";
	static final String MQ_QUEUE_MANAGER_SYMBOL = "queueManager";
	static final String MQ_CCSID_SYMBOL = "CCSID";
	static final String MQ_RECEIVERTIMEOUT ="receivertimeout";
	static final String DEFAULT_CALL_EXPRESSION_SYMBOL = "${callEx()}";
	static final String HTTP_MODE = "mode";
	static final String HTTP_URL = "url";
	static final String HTTP_CONNECTIONTIMEOUT = "connectionTimeout";
	static final String HTTP_SOTIMEOUT = "soTimeout";
	static final String HTTP_DEFAULTCONNPERHOST = "defaultMaxConnectionsPerHost";
	static final String HTTP_MAXCONNS = "MaxTotalConnections";
	static final String HEAD = "head";
	static final String ISFORM = "postType";
	static final String SENDCONTENT = "sendContent";
	static final String HTTP_CHARSET = "charset";
	static final String JMS_QUEUE = "queue";
	static final String JMS_URL = "url";
	static final String INNER_FILTER = "com.brilliance.eibs.core.service.instance.impl.InnerFilter";
	static final String LOG_FLAG = "############";

	// ------------added by weicong on 2016/4/01 -----------
	static final String KEY_STORE = "keystore";
	static final String KEY_STORE_PASS = "keystorepass";
	static final String TRUST_STORE = "truststore";
	static final String TRUST_STORE_PASS = "truststorepass";
	static final String KEY_STORE_TYPE = "keystoretype";
	static final String SSL_CONTEXT_ALGO = "algorithms";

	void setContext(Context context);

	void setElPaser(AbstractEL apacheEL);

	/**
	 * 注入连接定义
	 * 
	 * @param connectionDef
	 */
	void setIDef(IExecutableDef executableDef);

	IExecutableDef getIDef();

}
