package com.brilliance.eibs.core.service.instance;

import com.brilliance.eibs.core.frame.ISocketProxy;
import com.brilliance.eibs.core.service.instance.plugin.JdbcExecutor;
import com.brilliance.eibs.core.service.instance.plugin.JedisProxy;
import com.brilliance.eibs.core.service.instance.plugin.UdpProxy;

import java.sql.Connection;

/**
 * 接口资源存取接口
 */
public interface IResource {

    public static final String ERRORCODE_NORMAL = "00000";

    /**
     * 如果不放入上下文,处理接口过滤后的返回值,主要指非流资源.
     */
    public void setObject(Object object);

    public Object getObject();

    public Boolean getSuccess();

    public void setSuccess(Boolean success);

    public JdbcExecutor getExecutor();

    public void setExecutor(JdbcExecutor executor);

    public Object getResourceParameter(String key);

    public void addResourceParameter(String key, Object value);

    public Object[] getTransArgs();

    public void setTransArgs(Object[] transArgs);

    /**
     * 获取redis连接
     * 
     * @return
     */

    /**
     * 获取数据库连接
     * 
     * @return
     */
    public Connection getConnection();

    public void setConnection(Connection connection);

    public Connection getCntConnection();

    public void setCntConnection(Connection cntConnection);

    public ISocketProxy getSocketProxy();

    public void setSocketProxy(ISocketProxy socketProxy);

    public String getErrorcode();

    public String getDescrption();

    public void setErrorcode(String errorcode);

    public void setDescrption(String descrption);

    public String getInterfaceName();

    public void setInterfaceName(String interfaceName);

    public String getTransactionName();

    public void setTransactionName(String transactionName);

    public StringBuffer getLogbuffer();

    public void setLogbuffer(StringBuffer logbuffer);

    public String getDescription();

    public void setDescription(String description);

    public UdpProxy getUdpProxy();

    public void setUdpProxy(UdpProxy udpProxy);

    public JedisProxy getJedisProxy();

    public void setJedisProxy(JedisProxy jedisProxy);
    
    public Exception getException();
    
    public void setException(Exception exception);
}
