package com.brilliance.eibs.core.service.instance.plugin;

import com.jcraft.jsch.ChannelExec;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;

import java.io.IOException;
import java.io.InputStream;

public class SSHTool extends AbsCloseConnection {

	private String host;
	private int port;
	private String username;
	private String password;

	private Session session;

	private StringBuffer sb = new StringBuffer();

	public SSHTool(String host, int port, String username, String password) {
		this.host = host;
		this.port = port;
		this.username = username;
		this.password = password;
	}

	public void connect() throws JSchException {
		JSch jSch = new JSch();
		if (port <= 0)
			// 连接服务器，采用默认端口
			session = jSch.getSession(username, host);
		else
			// 采用指定的端口连接服务器
			session = jSch.getSession(username, host, port);
		session.setPassword(password);// 设置密码
		// 设置第一次登陆的时候提示，可选值：(ask | yes | no)
		session.setConfig("StrictHostKeyChecking", "no");
	}

	public void setTimeout(int timeout) throws JSchException {
		// 设置登陆超时时间
		session.connect(timeout);
	}

	public int exec(String command) throws JSchException, IOException {
		ChannelExec channel = null;
		try {
			channel = (ChannelExec) session.openChannel("exec");
			channel.setCommand(command);
			channel.setErrStream(System.err);
			channel.connect();
			// 避免关闭太快导致异常退出
			// Thread.sleep(1000);
			InputStream in = channel.getInputStream();
			byte[] tmp = new byte[1024];
			while (true) {
				while (in.available() > 0) {
					int i = in.read(tmp, 0, 1024);
					if (i < 0)
						break;
					sb.append(new String(tmp, 0, i));
				}
				if (channel.isClosed()) {
					if (in.available() > 0)
						continue;
					break;
				}
				try {
					Thread.sleep(1000);
				} catch (Exception ee) {
				}
			}
			return channel.getExitStatus();
			// } catch (InterruptedException e) {
		} catch (JSchException e) {
			throw e;
		} finally {
			if (null != channel)
				channel.disconnect();
		}
	}

	public String getResponseInfo() {
		return sb.toString();
	}

	@Override
	public void close() throws Exception {
		if (null != session)
			session.disconnect();
	}

}
