package com.brilliance.eibs.el;

import com.brilliance.eibs.core.exception.InterfaceException;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.Date;
import java.util.GregorianCalendar;

/**
 * 利用表达式功能，提供表达式${system.xxx}的配置方式<br>
 * 如提供一个getAbcd()方法,即可配置支持${system.abcd},只适合无参的函数
 * @author xiaoyuanzhen
 *
 */
public class Sys
{

  public long getCurrentTimeMillis()
  {
    return System.currentTimeMillis();
  }

  /**
   * 获取当前时间毫秒数
   * @return
   */
  public long getTime()
  {
    return new Date().getTime();
  }

  public Date getNowDate()
  {
    return new Date();
  }

  public String getCurrentPath()
  {
    return System.getProperty("user.dir");
  }

  public String getLineSeparator()
  {
    return System.getProperty("line.separator");
  }

  public int getLineSeparatorLength()
  {
    return getLineSeparator().length();
  }

  public String getEncoding()
  {
    return System.getProperty("file.encoding");
  }

  public XMLGregorianCalendar getCurrentXmlDate()
  {
    GregorianCalendar gc = new GregorianCalendar();
    gc.setTimeInMillis(new Date().getTime());
    XMLGregorianCalendar xgc;
    try
    {
      xgc = DatatypeFactory.newInstance().newXMLGregorianCalendar(gc);
    }
    catch (DatatypeConfigurationException e)
    {
      throw new InterfaceException("00105", "date type configuration error.", e);
    }
    return xgc;
  }

}
