package com.brilliance.eibs.factory;

import com.brilliance.eibs.core.model.IInterfaceDef;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BeanFactory
{
  private Map<String, IInterfaceDef>       interfaceMap = new HashMap<String, IInterfaceDef>();
  
  private List<Map<String, Object>> errorCodeList = new ArrayList<Map<String, Object>>();
  
  private List<Map<String, Object>> codeTableList=new ArrayList<Map<String,Object>>(); 
  
  
  public  void addErrorCodes(List<Map<String, Object>> list)
  {
    this.errorCodeList = list;
  }
  
  public  List<Map<String, Object>> getErrorCode()
  {
    return this.errorCodeList;
  }
  
  
  public  void addCodeTable(List<Map<String, Object>> list)
  {
    this.codeTableList = list;
  }
  
  public  List<Map<String, Object>> getCodeTable()
  {
    return this.codeTableList;
  }
  

  public IInterfaceDef getInterface(String key)
  {
    return interfaceMap.get(key);
  }
  

  public void setInterfaceMap(Map<String, IInterfaceDef> interfaceMap)
  {
    this.interfaceMap = interfaceMap;
  }

  public void addInterface(String key, IInterfaceDef interfaceDef)
  {
    this.interfaceMap.put(key, interfaceDef);
  }

  public Map<String, IInterfaceDef> getInterfaceMap()
  {
    return interfaceMap;
  }

  protected BeanFactory clone()
  {
    BeanFactory beanFactory = new BeanFactory();
    beanFactory.setInterfaceMap(new HashMap<String, IInterfaceDef>(interfaceMap));
    return beanFactory;
  }

  /**
   * @author hujun
   *
   * 自定义函数检索条件
   */
  public class FunctionKey
  {

    private String     name;
    private Class<?>[] parameterTypes;

    public Class<?>[] getParameterTypes()
    {
      return parameterTypes;
    }

    public void setParameterTypes(Class<?>[] parameterTypes)
    {
      this.parameterTypes = parameterTypes;
    }

    public String getName()
    {
      return name;
    }

    public void setName(String name)
    {
      this.name = name;
    }

    public FunctionKey( String name, Class<?>[] parameterTypes )
    {
      this.name = name;
      this.parameterTypes = parameterTypes;
    }

    @Override
    public boolean equals(Object obj)
    {
      return EqualsBuilder.reflectionEquals(this, obj);
    }

    @Override
    public int hashCode()
    {
      return HashCodeBuilder.reflectionHashCode(this);
    }
  }
}
