package com.brilliance.eibs.factory;

/**
 * 内存管理
 * 
 * @author xiaoyuanzhen
 *
 */
public class FactoryManager {
    public static int curFactoryNum = 0; // 当前内存块的序号
    public static final int facSize = 2; // 内存块数
    private static BeanFactory[] beanFactory = new BeanFactory[facSize];

    /**
     * 获取当前内存对象
     * 
     * @return
     */
    public static BeanFactory getBeanFactory() {
        if (beanFactory[curFactoryNum] == null) beanFactory[curFactoryNum] = new BeanFactory();
        return beanFactory[curFactoryNum];
    }

    /**
     * 清空当前内存
     * 
     * @return
     */
    public static BeanFactory getRenewFactory() {
        beanFactory[curFactoryNum] = new BeanFactory();
        return beanFactory[curFactoryNum];
    }

    /**
     * 获取下一块内存对象
     * 
     * @return
     */
    public static BeanFactory getNextBeanFactory() {
        int nextnum = nextNum();
//        if (beanFactory[nextnum] == null) beanFactory[nextnum] = beanFactory[curFactoryNum].clone();
        return beanFactory[nextnum]= beanFactory[curFactoryNum].clone();
    }

    /**
     * 下一块内存的序号
     * 
     * @return
     */
    private static int nextNum() {
        return (curFactoryNum + 1) % facSize;
    }

    /**
     * 切换到下一块内存
     */
    public static void switchNext() {
        curFactoryNum = nextNum();
    }

    /**
     * 切换到下一块内存，内存为参数指定内存
     * 
     * @param factory
     */
    public static void switchNext(BeanFactory factory) {
        curFactoryNum = nextNum();
        beanFactory[curFactoryNum] = factory;
    }


//    public static Logger logger = LogUtil.getLogger("services");

}
