package com.brilliance.eibs.monitor.nms;

import org.dom4j.*;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class LogMenuParser
{

  public List<LogMenuDto> parseMenuXML(String text)
      throws DocumentException
  {
    Document document = DocumentHelper.parseText(text);
    Element root = document.getRootElement();
    @SuppressWarnings("unchecked")
    Iterator<Element> it = root.elementIterator("menu");
    List<LogMenuDto> models = new ArrayList<LogMenuDto>();
    while (it.hasNext())
    {
      Element e = it.next();
      models.add(parseMenuNode(e));
    }
    return models;
  }

  private LogMenuDto parseMenuNode(Element node)
  {
    Attribute nameAttr = node.attribute("name");
    LogMenuDto model = new LogMenuDto(nameAttr.getValue());
    Attribute file = node.attribute("file");
    if (file == null)
    {
      List<LogMenuDto> models = new ArrayList<LogMenuDto>();
      @SuppressWarnings("unchecked")
      Iterator<Element> it = node.elementIterator("menu");
      while (it.hasNext())
      {
        Element e = it.next();
        models.add(parseMenuNode(e));
      }
      model.setOpen(true);
      model.setChildren(models);
    }
    else
      model.setFile(file.getValue());
    return model;
  }

}
