package com.brilliance.eibs.packet;

public class PacketHeader
{
  private char[] header;
  private int    count;

  public PacketHeader()
  {
    header = new char[0];
  }

  public char[] getHeader()
  {
    return header;
  }

  public char[] insertChars(char[] src)
  {
    char[] tempheader = new char[header.length + src.length];
    System.arraycopy(header, 0, tempheader, 0, header.length);
    count += src.length;
    System.arraycopy(src, 0, tempheader, header.length, src.length);
    header = tempheader;
    return src;
  }

  public char insertChar(char sc)
  {
    char[] tempheader = new char[header.length + 1];
    System.arraycopy(header, 0, tempheader, 0, header.length);
    count += 1;
    tempheader[header.length] = sc;
    header = tempheader;
    return sc;
  }

  public int getCount()
  {
    return count;
  }

  public void recycle()
  {
    header = new char[0];
    count = 0;
  }

  public void readHeader(PacketScanner packetScanner, String endTag)
      throws Exception
  {
    int length = endTag.toCharArray().length;
    try
    {
      while (true)
      {
        if (insertChar(packetScanner.peekChar()) == '/')
        {
          packetScanner.skipSpaces();
          if (insertChars(packetScanner.skipString(endTag.toCharArray())).length == length)
          {
            break;
          }
        }
      }
      packetScanner.skipSpaces();
      while (insertChar(packetScanner.peekChar()) != '>')
      {}
    }
    catch (ArrayIndexOutOfBoundsException e)
    {
      throw new Exception("报文头不存在或者配置有误");
    }
  }
}
