package com.brilliance.eibs.packet;

import com.brilliance.eibs.core.frame.ISocketProxy;
import com.brilliance.eibs.util.StringUtil;

import java.io.IOException;

public class PacketManager
{
  static final String PACKETHEAD = "head";

  static final String PACKETBODY = "body";

  public static Packet createPacket(ISocketProxy socketProxy, 
      String encoding, int datalen) throws IOException{
    Packet packet=new Packet(socketProxy, encoding, datalen);
    packet.fillPacket();
    return packet;
  }
  
  public static byte[] readPartOfPacket(String etag, Packet packet)
      throws Exception
  {
    if(StringUtil.isEmpty(etag))
      return null;
    String[] vals = etag.split(":");
    if (vals.length == 2)
    {
      if (PACKETHEAD.equalsIgnoreCase(vals[0]))
      {
        return readHeader(packet,vals[1]);
      }
    }
    else if (vals.length == 1)
    {
      if (PACKETBODY.equalsIgnoreCase(vals[0]))
      {
        return readBody(packet);
      }
    }
    return new byte[0];
  }

  private static byte[] readBody(Packet packet) throws Exception
  {
    return packet.readBody();
  }

  private static byte[] readHeader(Packet packet, String endTag) throws Exception
  {
    return packet.readHeader(endTag);
  }
}
