package com.brilliance.eibs.packet;

import com.brilliance.eibs.core.frame.ISocketProxy;
import com.sun.org.apache.xerces.internal.util.XMLChar;

import java.io.IOException;

public class PacketScanner
{
  private PacketReader packetReader;

  public void fillPacket() throws IOException{
    packetReader.channelRead();
  }
  
  public PacketScanner( ISocketProxy socketProxy, int datalen )
  {
    setPacketReader(new PacketReader(socketProxy, datalen));
  }

  public void setPacketReader(PacketReader pr)
  {
    this.packetReader = pr;
  }

  public char[] skipString(char[] s)
      throws IOException
  {
    final int length = s.length;
    char[] temp = new char[0];
    //首先确定缓存字符容量是否适合
    int beforeSkip = packetReader.position;

    for (int i = 0; i < length; i++)
    {
      if (!(packetReader.ch[beforeSkip++] == s[i]))
      {
        temp = new char[beforeSkip - packetReader.position];
        System.arraycopy(packetReader.ch, packetReader.position, temp, 0, temp.length);
        return temp;
      }
    }
    packetReader.position = packetReader.position + length;
    return s;
  }

  public char peekChar()
      throws IOException
  {
    return packetReader.ch[packetReader.position++];
  }

  public char[] getRemaining()
  {
    char[] remaining = new char[packetReader.totallength - packetReader.position];
    System.arraycopy(packetReader.ch, packetReader.position, 
        remaining, 0, remaining.length);
    return remaining;
  }

  public void skipSpaces()
  {
    while (XMLChar.isSpace(packetReader.ch[packetReader.position])){
      packetReader.position++;
    }
  }
}
