package com.brilliance.eibs.server.channel.server.impl;

import com.brilliance.eibs.server.channel.model.Channel;
import com.brilliance.eibs.server.channel.model.impl.AsyncFixedChannel;
import com.brilliance.eibs.server.connection.Connection;
import com.brilliance.eibs.server.connection.FilterChain;
import com.brilliance.eibs.server.connection.impl.TransFilter;
import com.brilliance.eibs.util.StringUtil;

public class AsyncFixedChannelServer
    extends AsyncChannelServer
{
  private int    length;
  private String requestInterfaceName;
  private String requestTransactionName;
  private String responseInterfaceName;
  private String responseTransactionName;

  public AsyncFixedChannelServer( int port, int destPort, String destIP, int length, String requestInterfaceName,
      String requestTransactionName, String responseInterfaceName, String responseTransactionName )
  {
    super(port, destPort, destIP);
    this.length = length;
    this.requestInterfaceName = requestInterfaceName;
    this.requestTransactionName = requestTransactionName;
    this.responseInterfaceName = responseInterfaceName;
    this.responseTransactionName = responseTransactionName;
  }

  @Override
  protected Channel createChannel(Connection in, Connection out)
  {
    FilterChain chain = new FilterChain();
    if (!StringUtil.isEmpty(requestInterfaceName) && !StringUtil.isEmpty(requestTransactionName))
      chain.addRequestFilter(new TransFilter(requestInterfaceName, requestTransactionName));
    if (!StringUtil.isEmpty(responseInterfaceName) && !StringUtil.isEmpty(responseTransactionName))
      chain.addResponseFilter(new TransFilter(responseInterfaceName, responseTransactionName));
    return new AsyncFixedChannel(in, out, this, length, chain);
  }
}
