package com.brilliance.eibs.server.connection;

import java.io.IOException;

public abstract class Detect
    implements Runnable
{
  private boolean isInterrupted = false;

  public boolean isInterrupted()
  {
    return isInterrupted;
  }

  public void reset()
  {
    isInterrupted = false;
  }

  public void interrupted()
  {
    isInterrupted = true;
    close();
  }

  @Override
  public void run()
  {
    try
    {
      while (!isInterrupted)
        handle();
    }
    catch (IOException e)
    {
      exception();
    }
  }

  protected abstract void exception();

  protected abstract void handle()
      throws IOException;

  protected abstract void close();
}
