package com.brilliance.eibs.server.connection;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class FilterChain
{

  private List<Filter> requestFilter  = new ArrayList<Filter>();
  private List<Filter> responseFilter = new ArrayList<Filter>();

  public void addRequestFilter(Filter f)
  {
    requestFilter.add(f);
  }

  public byte[] doRequestFilterChain(byte[] bytes)
  {
    for (Iterator<Filter> it = requestFilter.iterator(); it.hasNext();)
    {
      Filter f = it.next();
      bytes = f.filter(bytes);
    }
    return bytes;
  }

  public byte[] doResponseFilterChain(byte[] bytes)
  {

    for (Iterator<Filter> it = responseFilter.iterator(); it.hasNext();)
    {
      Filter f = it.next();
      bytes = f.filter(bytes);
    }
    return bytes;

  }

  public void addResponseFilter(Filter f)
  {
    responseFilter.add(f);
  }
}
