package com.brilliance.eibs.server.connection.impl;

import org.apache.commons.io.IOUtils;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

public class SimplexConnection
    extends CloseableConnection
{
  private Socket in;
  private Socket out;

  public SimplexConnection( Socket in, Socket out )
  {
    this.in = in;
    this.out = out;
  }

  @Override
  public void close()
  {
    IOUtils.closeQuietly(in);
    IOUtils.closeQuietly(out);
    isClosed = true;
  }

  @Override
  public InputStream getInputStream()
      throws IOException
  {
    return in.getInputStream();
  }

  @Override
  public OutputStream getOutputStream()
      throws IOException
  {
    return out.getOutputStream();
  }
}
