package com.brilliance.eibs.server.link_v2_0;

import java.io.IOException;
import java.util.concurrent.locks.Lock;

public class Heartbeat
    extends Detect
{
  private byte[] heartbeat;
  private Link   link;

  public Heartbeat( long interval, byte[] heartbeat, Link link )
  {
    super(interval);
    this.heartbeat = heartbeat;
    this.link = link;
  }

  public byte[] getHeartbeat()
  {
    return heartbeat;
  }

  public void setLink(Link link)
  {
    this.link = link;
  }

  @Override
  void process()
  {
    Lock lock = link.getLock();
    lock.lock();
    try
    {
      link.getLogger().debug("Send heartbeat...");
      link.write(heartbeat);
      setNextExecutionTime(System.currentTimeMillis());
    }
    catch (IOException e)
    {
      try
      {
        link.rebuild();
      }
      catch (IOException e1)
      {
        interrupted();
      }
      catch (InterruptedException e1)
      {
        interrupted();
      }
    }
    finally
    {
      lock.unlock();
    }
  }
}
