package com.brilliance.eibs.server.manager;

import com.brilliance.eibs.factory.FactoryManager;
import com.brilliance.eibs.factory.parser.impl.XmlParser;
import com.brilliance.eibs.listener.HotDeployListener;
import com.brilliance.eibs.main.Server;
import com.brilliance.eibs.util.Constants;
import com.brilliance.eibs.util.Serializable2FileUtil;

import java.util.List;
import java.util.Map;

public class BDHotDeployListener extends HotDeployListener {

    public BDHotDeployListener(XmlParser xmlParser) {
        super(xmlParser);
    }

    protected void doOnChange(Map<String, List<String>> changedFileMap) {
        boolean mainFileDeployedDown = false;// 标识主配置的热部署是否已经完成
        boolean serviceChanged = false;
        // support文件夹文件被修改
        if (changedFileMap.containsKey(Constants.ETC_PATH)) {
            List<String> filenames = changedFileMap.get(Constants.ETC_PATH);
            if (filenames.contains("commons.xml") || filenames.contains("functions.xml")) {// 重启所有服务
                Server.servers.clear();
                updateMap(pathnames);
                return;
            } else if (filenames.contains("services.xml")) {
                serviceChanged = true;
            } else {
                // 主配置文件重新初始化到新内存
                changeMainFiles();
                mainFileDeployedDown = true;
            }
        }
        if (changedFileMap.containsKey(Constants.BEANS_PATH)) {// 重新生成beans
            changeBeanFiles();
        }
        // services.xml文件被修改
        if (serviceChanged) {// 操作服务
                             // changeServicesCfg();
        }
        // main文件夹文件被修改
        if (changedFileMap.containsKey(XmlParser.MAIN_PATH)) {
            if (!mainFileDeployedDown) changeMainFiles();
            // 切换内存
            FactoryManager.switchNext();
        }
        updateMap(pathnames);
        if (!Serializable2FileUtil.hotDeploy && isAlive()) {
            interrupt();
            Server.listener = null;
        }
    }

}
