package com.brilliance.eibs.server.socket.impl;

import org.apache.mina.core.session.IoSession;
import org.apache.mina.filter.codec.ProtocolCodecFactory;
import org.apache.mina.filter.codec.ProtocolDecoder;
import org.apache.mina.filter.codec.ProtocolEncoder;

import java.nio.charset.Charset;

public class CodecFactory implements ProtocolCodecFactory {
	private final CustomEncoder encoder;
	private final CustomDecoder decoder;

	public CodecFactory() {
		this(Charset.defaultCharset(), 8);
	}

	public CodecFactory(Charset charSet) {
		this(charSet, 8);
	}

	public CodecFactory(int headlength) {
		this(Charset.defaultCharset(), headlength);
	}

	public CodecFactory(Charset charSet, int headlength) {
		this.encoder = new CustomEncoder(charSet);
		this.decoder = new CustomDecoder(charSet, headlength);
	}

	@Override
	public ProtocolDecoder getDecoder(IoSession session) throws Exception {
		return decoder;
	}

	@Override
	public ProtocolEncoder getEncoder(IoSession session) throws Exception {
		return encoder;
	}
}
