package com.brilliance.eibs.sqlite;

import java.net.URL;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.brilliance.eibs.el.CommonFunctionUtils;
import com.brilliance.eibs.util.StringUtil;

/**
 * sqlite数据库操作
 **/
public class Sqlite_OP {
	public final static String SQLITE_ETC = "cfg/etc";

	// 数据库连接
	public Connection getConnection(String dbname) {
		String str = null;
		if (StringUtil.isEmpty(dbname) || dbname.equals("swift")) {
			str = SQLITE_ETC + "/swift.db";
		} else {
			str = SQLITE_ETC + "/" + dbname + ".db";
		}
		try {
			Class.forName("org.sqlite.JDBC");
			// URL url = getClass().getClassLoader().getResource(str);
			URL url = CommonFunctionUtils.getCommonURL(str);
			// String path = url.getPath();
			String path = url.toExternalForm();
			path = CommonFunctionUtils.decodeURL(path);
			// System.out.println("path=" + url.getPath());
			// System.out.println("externalForm=" + path);
			String os = System.getProperty("os.name");
			Connection conn = null;
			if (os.startsWith("AIX")) {
				// System.out.println("aix connection");
				conn = DriverManager.getConnection("jdbc:sqlite://" + url.getPath());
			} else {
				// System.out.println("no aix connection");
				conn = DriverManager.getConnection("jdbc:sqlite:" + path);
			}
			conn.setAutoCommit(false);
			return conn;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * 测试sqlite程序
	 **/
	public void searchAll() {
		try {
			Connection conn = getConnection("cod");
			Statement stat = conn.createStatement();
			ResultSet rs = stat.executeQuery("SELECT * FROM COD");
			int i = 0;
			while (rs.next() && i < 100) {
				i++;
				System.out.println("num: " + rs.getString("inr"));
			}

			rs.close();
			stat.close();
			conn.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws SQLException {
		new Sqlite_OP().searchAll();
	}
}
