package com.brilliance.eibs.util;

import java.lang.reflect.Array;

/**
 * 数组常用功能
 * @author xiaoyuanzhen
 *
 */
public class ArrayUtil
{
  /**
   * 是否是基本类型数组
   * @param object
   * @return
   */
  public static boolean isPrimitiveArray(Object object)
  {
    return (object instanceof int[]) || (object instanceof long[]) || (object instanceof float[]) || (object instanceof double[])
        || (object instanceof short[]) || (object instanceof byte[]) || (object instanceof char[]) || (object instanceof boolean[]);
  }

  /**
   * 是否是数组类型
   * @param object
   * @return
   */
  public static boolean isArray(Object object)
  {
    if ((object instanceof Object[]) || isPrimitiveArray(object))
      return true;
    return false;
  }

  /**
   * 数组大小是否相等
   * @param obj1
   * @param obj2
   * @return
   */
  public static boolean arraySizeEquals(Object obj1, Object obj2)
  {
    if (!isArray(obj1) || !isArray(obj2))
      return false;
    int len1 = Array.getLength(obj1);
    int len2 = Array.getLength(obj2);
    if (len1 != len2)
      return false;
    for (int i = 0; i < len1; i++)
    {
      Object subObj1 = Array.get(obj1, i);
      Object subObj2 = Array.get(obj2, i);
      if (isArray(subObj1) && isArray(obj2))
      {
        return arraySizeEquals(subObj1, subObj2);
      }
      else if (!isArray(subObj1) && !isArray(subObj2))
      {
        continue;
      }
      else
        return false;
    }
    return true;
  }
}
