package com.brilliance.eibs.util;

import com.brilliance.eibs.bean.DynamicClassLoader;
import com.brilliance.eibs.bean.DynamicCompiler;

import javax.tools.DiagnosticCollector;
import javax.tools.JavaFileObject;
import java.io.File;

public class DynamicClassLoaderUtil
{
  /**
   * 动态重新加载class，并返回对应的实例
   * **/
  public static Object loadInstance(String classPath, String className)
      throws InstantiationException, IllegalAccessException, ClassNotFoundException
  {
    return loadClass(classPath, className).newInstance();
  }

  public static Class<?> loadClass(String classPath, String className)
      throws InstantiationException, IllegalAccessException, ClassNotFoundException
  {
    className = className + ".class";
    Class<?> c = new DynamicClassLoader(Thread.currentThread().getContextClassLoader()).loadClass(classPath, className);
    return c;
  }

  /**
   * 编译buildpath下的java文件
   * @param buildpath
   * @param despath
   * **/
  public static boolean compile(String buildpath, String despath)
  {
    try
    {
      File fp = new File(despath);
      // 编译的目标文件目录不存在，则创建目录   
      if (!fp.exists())
      {
        fp.mkdirs();
      }
      DiagnosticCollector<JavaFileObject> diagnostics = new DiagnosticCollector<JavaFileObject>();
      DynamicCompiler dynamicCompilerUtil = new DynamicCompiler();
      boolean compilerResult = dynamicCompilerUtil.compiler("UTF-8", System.getProperty("java.class.path"), buildpath, "", despath,
          diagnostics);
      if (compilerResult)
      {
        System.out.println("----编译成功-----");
        return true;
      }
      else
      {
        System.out.println("+++++编译失败++++++");
      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
    return false;

  }

  public static void main(String[] arguments)
      throws Exception
  {

    String classPath = "D:/Program/workspace64/TestWebService/bin/";
    String className = "com.brilliance.cn.Person";
    Object o = DynamicClassLoaderUtil.loadClass(classPath, className);
 /*   System.out.println(o);
    System.out.println(MethodUtils.invokeMethod(o, "getName", new Object[]{"1", "2"}));
    //Thread.sleep(10000);
    o = DynamicClassLoaderUtil.loadClass(classPath, className);
    System.out.println(MethodUtils.invokeMethod(o, "getName", new Object[]{"1", "2"}));
    System.out.println(o);*/
     DynamicClassLoaderUtil.compile("e:/src","e:/src1");

  }

}
