package com.brilliance.eibs.util;

import org.apache.commons.io.IOUtils;
import org.apache.html.dom.HTMLDocumentImpl;
import org.cyberneko.html.parsers.DOMFragmentParser;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Node;
import org.w3c.dom.html.HTMLDocument;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Properties;

public class Html2Xml
{
  public static void main(String args[])
      throws FileNotFoundException, IOException, Exception, Error
  {
    DocumentFragment df = Html2Xml.getSourceNodeByStr(IOUtils.toString(new FileInputStream("d:/input.htm")), true, "UTF-8");
    System.out.println(Html2Xml.genToXml(df, "UTF-8"));
  }

  public static void genXmlFile(Node output, File file)
      throws Exception, Error
  {
    TransformerFactory tf = TransformerFactory.newInstance();
    Transformer transformer = tf.newTransformer();
    DOMSource source = new DOMSource(output);
    java.io.FileOutputStream fos = new java.io.FileOutputStream(file);
    StreamResult result = new StreamResult(fos);
    Properties props = new Properties();
    props.setProperty("encoding", "GB2312");
    props.setProperty("method", "xml");
    props.setProperty("omit-xml-declaration", "yes");

    transformer.setOutputProperties(props);

    transformer.transform(source, result);
    fos.close();

  }

  public static String genToXml(Node output, String encode)

  {
    TransformerFactory tf = TransformerFactory.newInstance();
    ByteArrayOutputStream bos = null;
    String str = null;
    try
    {
      Transformer transformer = tf.newTransformer();
      DOMSource source = new DOMSource(output);
      bos = new ByteArrayOutputStream();
      StreamResult result = new StreamResult(bos);
      Properties props = new Properties();
      props.setProperty("encoding", encode);
      props.setProperty("method", "xml");
      props.setProperty("omit-xml-declaration", "yes");

      transformer.setOutputProperties(props);
      transformer.transform(source, result);

      str = bos.toString(encode);

      bos.close();

    }
    catch (TransformerException e)
    {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
    catch (UnsupportedEncodingException e)
    {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
    catch (IOException e)
    {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }

    return str;
  }

  public static DocumentFragment getSourceNodeByStr(String str, boolean fromfile, String encode)

  {
    DOMFragmentParser parser = new DOMFragmentParser();
    HTMLDocument document = new HTMLDocumentImpl();
    DocumentFragment fragment = document.createDocumentFragment();

    if (fromfile)
    {

      try
      {
        ByteArrayInputStream bis = new ByteArrayInputStream(str.getBytes(encode));
        InputSource is = new InputSource(bis);
        is.setEncoding(encode);
        parser.parse(is, fragment);
        bis.close();
      }
      catch (SAXException e)
      {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }
      catch (IOException e)
      {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }

    }

    return fragment;

  }

  public DocumentFragment getSourceNode(String path, boolean fromfile)
      throws Exception, Error
  {
    DOMFragmentParser parser = new DOMFragmentParser();
    HTMLDocument document = new HTMLDocumentImpl();
    DocumentFragment fragment = document.createDocumentFragment();

    if (path != null && !path.trim().equals(""))
    {
      String tmp = path;

      if (fromfile)
      {
        File input = new File(path);
        FileReader fr = new FileReader(input);
        InputSource is = new InputSource(fr);
        parser.parse(is, fragment);
        fr.close();
      }
      else
      {

        URL url = new URL(tmp);
        HttpURLConnection con = (HttpURLConnection) url.openConnection();
        InputStream inputs = con.getInputStream();
        InputStreamReader isr = new InputStreamReader(inputs, "GBK");
        InputSource source = new InputSource(isr);
        parser.parse(source, fragment);
      }
      return fragment;
    }
    else
    {
      return null;
    }

  }

  //  public static String getFileName()
  //      throws Exception
  //  {
  //    Calendar c = Calendar.getInstance();
  //    String name = "tmp" + c.get(Calendar.YEAR) + (c.get(Calendar.MONTH) < 9 ? "0" : "") + (c.get(Calendar.MONTH) + 1)
  //        + (c.get(Calendar.DAY_OF_MONTH) < 10 ? "0" : "") + c.get(Calendar.DAY_OF_MONTH) + (c.get(Calendar.HOUR_OF_DAY) < 10 ? "0" : "")
  //        + c.get(Calendar.HOUR_OF_DAY) + (c.get(Calendar.MINUTE) < 10 ? "0" : "") + c.get(Calendar.MINUTE)
  //        + (c.get(Calendar.SECOND) < 10 ? "0" : "") + c.get(Calendar.SECOND) + (c.get(Calendar.MILLISECOND) < 10 ? "0" : "")
  //        + (c.get(Calendar.MILLISECOND) < 100 ? "0" : "") + c.get(Calendar.MILLISECOND);
  //    return name;
  //  }

}
