package com.brilliance.eibs.util;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class HtmlUtil
{

  /**
   * 提供HTML文件转换成XML格式相关API,要考虑HTML和XHTML中单标签的的区别
   * 
   * @author gechengyang
   * **/

  public static String replaceStr(String htmlStr)
  {
    Pattern p_style;
    Matcher m_style;
    //替换HTML单标签
    List<String> list = new ArrayList<String>();
    list.add("frameborder");
    for (String tag : list)
    {
      String regEx_style1 = tag + "\\s*=\\s*[0-9]+\\s*";
      p_style = Pattern.compile(regEx_style1);
      m_style = p_style.matcher(htmlStr);
      while (m_style.find())
      {
        String s = m_style.group();
        htmlStr = htmlStr.replace(s, " ");
      }
    }
    return htmlStr;
  }

  //替换单个未关闭标签
  public static String replaceHTML(String htmlStr)
  {
    Pattern p_style;
    Matcher m_style;
    //替换HTML单标签
    List<String> list = new ArrayList<String>();
    list.add("img");
    list.add("link");
    list.add("base");
    //    list.add("hr");
    //    list.add("br");
    //list.add("meta");

    for (String tag : list)
    {
      String regEx_style1 = "<\\s*" + tag + "[\\s+([^>]*)]*\\s*>";
      p_style = Pattern.compile(regEx_style1);
      m_style = p_style.matcher(htmlStr);
      while (m_style.find())
      {
        String s = m_style.group();
        String replace = s.replace(">", "/>");
        htmlStr = htmlStr.replace(s, replace);
      }
    }
    return htmlStr;
  }

  public static String fitlerHtml(String htmlStr)
  {
    Pattern p_style;
    Matcher m_style;
    //替换HTML单标签
    List<String> list = new ArrayList<String>();
    list.add("style");
    list.add("script");
    for (String tag : list)
    {
      String regEx_style1 = "<[\\s]*?" + tag + "[^>]*?>[\\s\\S]*?<[\\s]*?\\/[\\s]*?" + tag + "[\\s]*?>";
      p_style = Pattern.compile(regEx_style1);
      m_style = p_style.matcher(htmlStr);
      while (m_style.find())
      {
        String s = m_style.group();
        htmlStr = htmlStr.replace(s, "");
      }
    }

    int index = htmlStr.indexOf("<html");
    if (index != -1)
      htmlStr = htmlStr.substring(index);
    htmlStr = htmlStr.replace("&nbsp;", " ");
    htmlStr = htmlStr.replace("&copy;", " ");
    htmlStr = htmlStr.replace("&amp;", " ");
    htmlStr = htmlStr.replace("&lt;", " ");
    htmlStr = htmlStr.replace("&gt;", " ");
    htmlStr = htmlStr.replace("&quot;", " ");
    htmlStr = htmlStr.replace("&reg;", " ");
    htmlStr = htmlStr.replace("<br>", " ");
    htmlStr = htmlStr.replace("<hr>", " ");

    return htmlStr;
  }

  public static String html2Xml(String htmlStr)
  {
    htmlStr = replaceStr(htmlStr);
    htmlStr = fitlerHtml(htmlStr);
    htmlStr = replaceHTML(htmlStr);

    return htmlStr;
  }

  public static void main(String[] args)
  {
    //    String st = html2Xml("frameborder = 0");
    //    System.out.println(st);
    System.out.println(replaceHTML("<img a='src'><hr>"));
  }

}
