package com.brilliance.eibs.util;

import org.apache.log4j.FileAppender;
import org.apache.log4j.MDC;
import org.apache.log4j.RollingFileAppender;
import org.apache.log4j.spi.LoggingEvent;

import java.io.File;
import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.Map;

public class MyRollingFileAppender extends RollingFileAppender {
	private Map<String, FileAppender> appenderCache = new HashMap<String, FileAppender>();
	private Map<FileAppender, String> appenderId = new HashMap<FileAppender, String>();
	String logFileDirectorNam = "";
	DateFormat dateFormat = null;

	{
		if (!StringUtil.isEmpty(PropertyUtil.getProperty("sys.properties",
				"LOG_STATEGY"))) {
			logFileDirectorNam = PropertyUtil.getProperty("sys.properties",
					"LOG_STATEGY");
			dateFormat = new SimpleDateFormat(logFileDirectorNam);
		}
	}

	@Override
	public synchronized void doAppend(LoggingEvent event) {

		int idx = event.getLoggerName().indexOf("/");
		String key = idx == -1 ? event.getLoggerName() : event.getLoggerName()
				.substring(idx + 1);

		String id = null;
		FileAppender appender = null;
		id = (String) event.getMDC(LogUtil.LOG_FILE_NAME_SYMBOL);
		if (StringUtil.isEmpty(id)) {
			String idname = "services";
			id = idname;
			MDC.put(LogUtil.LOG_FILE_NAME_SYMBOL, idname);
		}

		appender = appenderCache.get(key);
		if (appender == null) {
			try {
				appender = createAppender(id,key);
			} catch (IOException e) {
				// 因为该类属于log4j，顾不知道如何处理异常，直接抛出
				throw new RuntimeException("创建appender失败[" + e.getMessage() + "]",e);
			}
		}
		if (null != appender) {
			if (!id.equals(appenderId.get(appender))) {
				appender=reCreateApppender(id,key,appender);
			}
			appender.doAppend(event);
		}

	}

	private FileAppender reCreateApppender(String name,String key,FileAppender appender){
		appenderCache.remove(key);
		appenderId.remove(appender);
		appender.close();
		appender=null;
		try {
			return createAppender(name,key);
		} catch (IOException e) {
			// 因为该类属于log4j，顾不知道如何处理异常，直接抛出
			throw new RuntimeException("创建appender失败[" + e.getMessage() + "]",e);
		}
	}
	
	private FileAppender createAppender(String name,String key) throws IOException {
		String directory = StringUtil.isEmpty(getFile()) ? ClassPathUpdater
				.addClasspath(LogUtil.LOG_PATH) : getFile();
		RollingFileAppender result = new RollingFileAppender(getLayout(),
				directory + File.separator + name + ".log");
		result.setName(getName());
		result.setLayout(getLayout());
		result.setAppend(getAppend());
		result.setBufferedIO(getBufferedIO());
		result.setBufferSize(getBufferSize());
		result.setEncoding(getEncoding());
		result.setErrorHandler(getErrorHandler());
		result.setImmediateFlush(getImmediateFlush());
		result.setThreshold(getThreshold());
		result.setMaxBackupIndex(getMaxBackupIndex());
		result.setMaximumFileSize(getMaximumFileSize());
		appenderCache.put(key, result);
		appenderId.put(result, name);
		return result;
	}

}
