package com.brilliance.eibs.util;

import com.swetake.util.Qrcode;

import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.UnsupportedEncodingException;

public class QrCodeUtil {
    /**
     * 二维码生成器
     * @author gechengyang
     */
    /**
     * 生成二维码(QRCode)图片
     *
     * @param content
     * @param imgPath
     */

    public static boolean encoderQRCode(String content, String imgPath) {
        boolean flg = true;
        try {

            Qrcode qrcodeHandler = new Qrcode();
            qrcodeHandler.setQrcodeErrorCorrect('M');
            qrcodeHandler.setQrcodeEncodeMode('B');
            qrcodeHandler.setQrcodeVersion(7);
            System.out.println(content);
            byte[] contentBytes = content.getBytes("gb2312");
            BufferedImage bufImg = new BufferedImage(140, 140, BufferedImage.TYPE_INT_RGB);

            Graphics2D gs = bufImg.createGraphics();
            gs.setBackground(Color.WHITE);
            gs.clearRect(0, 0, 140, 140);
            // 设定图像颜色> BLACK
            gs.setColor(Color.BLACK);
            // 设置偏移量 不设置可能导致解析出错
            int pixoff = 2;

            // 输出内容> 二维码
            if (contentBytes.length > 0 && contentBytes.length < 120) {
                boolean[][] codeOut = qrcodeHandler.calQrcode(contentBytes);
                for (int i = 0; i < codeOut.length; i++) {
                    for (int j = 0; j < codeOut.length; j++) {
                        if (codeOut[j][i]) {
                            gs.fillRect(j * 3 + pixoff, i * 3 + pixoff, 3, 3);
                        }
                    }
                }
            } else {
                flg = false;
                System.err.println("QRCode content bytes length = " + contentBytes.length + " not in [ 0,120 ]. ");
            }
            gs.dispose();
            bufImg.flush();
            File imgFile = new File(imgPath);
            // 生成二维码QRCode图片
            ImageIO.write(bufImg, "png", imgFile);
        } catch (Exception e) {
            flg = false;
            e.printStackTrace();
        }
        return flg;
    }

    /**
     * @param args the command line arguments
     * @throws UnsupportedEncodingException
     */

    public static void main(String[] args)
            throws UnsupportedEncodingException {

        String imgPath = "G:/2.jpg";
        String name = "zhangsan";
        //String content = "HID-XXXXXX001";
        //    String content = "http://172.17.2.130:8082/machine?action=checkmacid&macid=HID-XXXXXX001&username="+name;
        //  String content = "http://192.168.0.102:8082/machine?action=checkmacid&macid=HID-XXXXXX001&username="+name;
        String content = "http://192.168.0.102:8082/machine?action=checkmacid&macid=HID-XXXXXX001&usrid='00000010'&usrnam=" + name;
        QrCodeUtil.encoderQRCode(content, imgPath);
        System.out.println("encoder QRcode success");
    }
}
