package com.brilliance.eibs.util;

import com.brilliance.eibs.core.frame.ISocketProxy;

import java.io.IOException;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class SocketManagerFactoryUtil {

	private static Map<String, ISocketProxy> map = new ConcurrentHashMap<String, ISocketProxy>();

	private static Object lock = new Object();

	public static void addSocketProxy(String key, ISocketProxy socketProxy) {
		/* if (!map.containsKey(key)) */
		synchronized (lock) {
			map.put(key, socketProxy);
		}

	}

	public static ISocketProxy getSocketProxyofManager(String key) {
		return map.get(key);
	}

	public static Map<String, ISocketProxy> getSocketProxyMap() throws IOException {
		return map;
	}

	public synchronized static void removeProxy(String key) {
		synchronized (lock) {
			if (map.containsKey(key))
				map.remove(key);
		}
	}

	public static boolean existProxy(String key) {

		return map.containsKey(key);
	}

	public static boolean isalive(String key) {

		if (map.get(key) != null) {
			return map.get(key).isConnected();
		}
		return false;
	}

	public static String findIdbySocketProxy(ISocketProxy socketProxy) {

		synchronized (lock) {
			for (String key : map.keySet()) {
				if (map.get(socketProxy).equals(socketProxy))
					return key;
			}
		}
		return null;

	}
}
