package com.brilliance.eibs.util;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUploadBase.FileSizeLimitExceededException;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.UnsupportedEncodingException;
import java.util.List;

public class UploadUtil {

	public static boolean upload(HttpServletRequest request, HttpServletResponse response, String basePath) {
		boolean uploadflg = true;

		try {

			request.setCharacterEncoding("utf-8");// 防止中文名乱码
			int sizeThreshold = 1024 * 6; // 缓存区大小
			File repository = new File(basePath); // 缓存区目录
			if (!repository.exists()) {
				repository.mkdirs();
			}
			long sizeMax = 1024 * 1024 * 2000;// 设置文件的大小为2000M
			final String allowExtNames = "jpg,gif,bmp,rar,rar,txt,docx,zip";
			DiskFileItemFactory diskFileItemFactory = new DiskFileItemFactory();
			diskFileItemFactory.setRepository(repository);
			diskFileItemFactory.setSizeThreshold(sizeThreshold);
			ServletFileUpload servletFileUpload = new ServletFileUpload(diskFileItemFactory);
			servletFileUpload.setSizeMax(sizeMax);

			List<FileItem> fileItems = null;
			fileItems = servletFileUpload.parseRequest(request);

			for (FileItem fileItem : fileItems) {
				String filePath = fileItem.getName();
				System.out.println(filePath);
				if (filePath == null || filePath.trim().length() == 0)
					continue;
				String fileName = filePath.substring(filePath.lastIndexOf(File.separator) + 1);
				// String fileName=String.valueOf(System.currentTimeMillis());
				String extName = filePath.substring(filePath.lastIndexOf(".") + 1);
				// fileName+="."+extName;
				if (allowExtNames.indexOf(extName) != -1) {
					try {
						fileItem.write(new File(basePath + File.separator + fileName));
					} catch (Exception e) {
						e.printStackTrace();
					}
				} else {
					uploadflg = false;
				}
			}
		} catch (FileSizeLimitExceededException e) {
			System.out.println("file size is not allowed");
			uploadflg = false;
		} catch (FileUploadException e1) {
			uploadflg = false;
			e1.printStackTrace();
		} catch (UnsupportedEncodingException e1) {
			uploadflg = false;
			e1.printStackTrace();
		}

		return uploadflg;

	}
}
