package com.brilliance.eibs.util;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.*;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ExcelUtil {

	private static final int unloadExcel(Object paramObject, Row paramRow, int paramInt) {
		Cell localCell = paramRow.createCell(paramInt);
		if ((paramObject != null) && ((paramObject instanceof Number))) {
			localCell.setCellType(0);
			localCell.setCellValue(((Number) paramObject).doubleValue());
		} else {
			localCell.setCellType(1);
			if ((paramObject == null) || ((paramObject instanceof String)))
				localCell.setCellValue((String) paramObject);
			else
				localCell.setCellValue(paramObject.toString());
		}
		return paramInt + 1;
	}

	private static final void unloadExcel(List paramList, Sheet paramSheet) {
		int i = 0;
		Iterator localIterator1 = paramList.iterator();
		while (localIterator1.hasNext()) {
			Object localObject1 = localIterator1.next();
			Row localRow = paramSheet.createRow(i);
			int j = 0;
			if ((localObject1 instanceof Object[])) {
				for (Object localObject2 : (Object[]) localObject1) {
					j = unloadExcel(localObject2, localRow, j);
				}
			} else if (localObject1 instanceof Map) {
				Map map = (Map) localObject1;
				for (Object key : map.keySet()) {
					j = unloadExcel(map.get(key), localRow, j);
				}
			}
			i++;
		}
	}

	public static final void unloadExcel(List[] paramArrayOfList, String[] paramArrayOfString, OutputStream localOutputStream, boolean paramBoolean) {
		Workbook localHSSFWorkbook = paramBoolean ? new XSSFWorkbook() : new HSSFWorkbook();
		try {
			for (int i = 0; i < paramArrayOfList.length; i++) {
				List localList = paramArrayOfList[i];
				String str = paramArrayOfString[i];
				Sheet localSheet = StringUtil.isEmpty(str) ? localHSSFWorkbook.createSheet() : localHSSFWorkbook.createSheet(str);
				unloadExcel(localList, localSheet);
			}
			localHSSFWorkbook.write(localOutputStream);
			localOutputStream.flush();
			localOutputStream.close();
		} catch (IOException localIOException) {
			localIOException.printStackTrace();
			// log.error("unload Excel error.", localIOException);
		}
	}

	public static final void unloadExcel(List paramList, String pathname, boolean paramBoolean) throws FileNotFoundException {
		OutputStream oStream = new FileOutputStream(new File(pathname));
		unloadExcel(new List[] { paramList }, new String[1], oStream, paramBoolean);
	}

	public static void main(String[] args) throws FileNotFoundException {
		// wList<Object>
		List<Object[]> list = new ArrayList<Object[]>();
		for (int i = 0; i < 100000; i++) {
			list.add(new Object[] { "abc", "def" });
			list.add(new Object[] { "abc1", "def1" });
		}
		unloadExcel(list, "d:/1.xls", true);

	}

}
